#ifndef FER221_H
#define FER221_H 
 
/*  Fermat 64 bit computer algebra system for Mac.
    Copyright (C) 2018 Robert H. Lewis.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* May 2003.  Attempt to split old fer220 by putting stuff here.  We wouldn't
   neeed the quoly except we still want an interrupt facility.   */

#include "ferm120.h"
#include "fer320.h"
#include "fer220.h"
/*
#include <Types.h>
#include <QuickDraw.h>
#include <Events.h>
#include <OSUtils.h>
#include <Files.h>
#include <Devices.h>
#include <DeskBus.h>
#include <DiskInit.h>
#include <Disks.h>
#include <Errors.h>
#include <Memory.h>
#include <Retrace.h>
#include <SegLoad.h>
#include <Serial.h>
#include <Shutdown.h>
#include <Slots.h>
#include <Sound.h>
#include <Start.h>
#include <Timer.h>
#include <Events.h>
#include <Controls.h>
#include <Desk.h>
#include <Windows.h>
#include <TextEdit.h>
#include <Dialogs.h>
#include <Fonts.h>
#include <Lists.h>
#include <Menus.h>
#include <Resources.h>
#include <Scrap.h>
#include <ToolUtils.h>
#include <FCntl.h>
#include "packages.h"
#include "sane.h"
*/

#include <stdint.h>

// extern int32_t reduce2_cnt; // May 2021


struct do_total_degree_EnvRec {  // Dec 2021
  int32_t last;
  /* n is not a number and n^.denom = nil. May 1997.
     Compute the subpolynomial of n consisting of all terms with total degree k involving
     the variables named by q^. laurent ok. k could be negative. */
  
  Boolean searchlist[max_number_polys];
};
typedef struct do_total_degree_EnvRec do_total_degree_EnvRec;

extern void sparse_minors_det(quolyptr n, sparseptr *spar, int32_t row, Boolean *ar_free, imptr md); 
    /* Dec 2000   Mar 2004*/

extern void int_sparse_minors_det(Longiptr n, sparseptr *spar, int32_t row, Boolean *ar_free, imptr md);  
     /* Nov 2000, Mar 2004 */

extern Boolean sparse_rat_poly_determ(sparseptr spar, int16_t polydepth, int32_t m, quolyptr q, poly fct, int32_t this_deg, 
     int32_t this_deg2, int32_t this_deg3, int32_t the_power, int32_t numprimes);  /* Jul 2004. Jan 2008. Oct 2009  Jan 2021 */

extern void hamilton_path_driver(sparseptr *spar, int32_t row, quolyptr n, poly f);

// extern void free_work(void);  moved Jan 2017

extern void gcd_0_poly(quolyptr n, quolyptr x);

extern void Lpolygcd2(polyptrr u, polyptrr v, polyptrr r, polypt pt);

extern void trial_divide(quolyptr n, quolyptr m, Boolean wantquot, Boolean fast_yes, Boolean SDivide,
     Boolean *use_n);  /*  Dec 2016 */

extern void findlcm(quolyptr n, sparseptr spar, int32_t spot, int32_t total_rows, int32_t target_rows, int32_t cols);

extern void powermod(quolyptr n, quolyptr modder, imptr expont, Boolean showit);

extern void irreducible_poly(quolyptr n, int32_t level, Boolean do_content);  // May2 2022

extern void differentiate(quolyptr n, int16_t height, int32_t degree);

extern void tot_eval_poly(poly q, quoly arg, quolyptr n, int16_t level, int16_t skip);

extern void tot_eval_poly2(poly q, quoly arg, quolyptr n, int16_t level, int16_t skip, int32_t count); 
          /* Mar 2005 */

extern void total_sq_free(polyptrr x, polyptrr sq, Longiptr count, Boolean first, polypt pt);

extern void factor_poly(polyptrr a, polyptrr sq, Longiptr count, Boolean leave_early, Boolean showit, int32_t level, int16_t code, int16_t depth, int16_t lower_dep, int16_t invoked, poly orig);  // Nov 2021 Feb 2023

extern void poly_change_num(polyptrr p);

extern void quoly_pth_root(quolyptr n);

extern void general_coef(poly n, polyptrr ans, quoly q, textptr inf, nameptr *flag);

extern void quoly_leading_num_coef(quolyptr x, quolyptr n);   /* Oct 2005 */

extern void quoly_trail_num_coef(quolyptr x, quolyptr n);   /* Jul 2008 */

extern void quoly_mono_num_coef(quolyptr x, quolyptr n, poly m);   /* Jul 2008 */

extern void quoly_z_num_coef(quolyptr x, quolyptr n);   /* Jul 2008 */

extern void order_of_field(imptr n, Boolean err, int32_t level);

extern void pop_gcd_stash(void);

// extern void free_arr(workptr ar, arr_descr *arf);   moved Jan 2017

extern void int_determ(quolyptr n, arrptr q, workptr beta, int32_t rows, quolyptr pseudodet);

extern void intnormal(quolyptr n, arrptr q, boolarray *want, workptr alpha, workptr beta, workptr alphinv, 
      workptr betinv, Boolean wantmod, imptr pseudodet, spar_arr *auxspar, int32_t index);

extern void trivial(int32_t n, int32_t r, quolyptr m);

extern void from_table(int32_t n, int32_t r, quolyptr m);

extern void rat_binom(int32_t n, int32_t r, quolyptr m);

extern void insertarr(tokentipe *let, int32_t r, int32_t c, Boolean liner);

extern void sparse_qq_set(int32_t i, sparseptr *sp, quolyptr qq);  /* July 1998 */

extern void normalize(quolyptr n, arrptr q, boolarray *want, workptr alpha, workptr beta, workptr alphinv, 
      workptr betinv);

extern void red_row_ech(Boolean reduce, quolyptr n, arrptr q, boolarray *want, workptr alpha, workptr alphinv,
     spar_arr *auxspar, int32_t stop); /* Nov 2000 Apr2 2016 Feb 2018 */

extern void fract_free_lu(Boolean colsok, quolyptr n, arrptr q, boolarray *want, workptr pivots, 
     workptr lower, workptr alpha, workptr alphinv, workptr beta, workptr betinv);

extern void intcolred(quolyptr n, arrptr q, boolarray *want, workptr alpha, workptr beta, workptr 
     alphinv, workptr betinv, spar_arr *auxspar, Boolean wantmod, imptr pseudodet);  /* July 1998 */

extern void add_to_diag(quoly m, sparseptr spar, int32_t rows);

extern void get_stream(nameptr *p, textptr inf, nameptr *flag);

extern void quoly_abs(quoly q);

extern void quoly_great_int(quolyptr q);

extern void quoly_change_to_mod(quolyptr q);

extern void sparse_chpoly(sparseptr spar, int32_t rows, quolyptr n);

extern void sparse_rowreduce(quolyptr n, arrptr q, Boolean pseudo, boolarray *want, workptr alpha, 
                            spar_arr *auxspar, int32_t cut, int32_t start);  // Aug 2018

extern void finish_equal(int32_t index, quolyptr n, quolyptr x, quolyptr y, boolarray *want);

extern void gershgorn(quolyptr n, arrptr q, int32_t rows);

extern int32_t codegree(poly q, int32_t level);

extern void quoly_add(quoly n, quoly m, quolyptr p);

extern void quoly_sub(quoly n, quoly m, quolyptr p);

extern void quoly_quot(quoly n, quoly m, quolyptr p, Boolean nogcd);

extern void randomize(Boolean again, quolyptr n);

extern void inumber_power(Longiptr n, Longiptr e);

extern void quoly_differen_once(quolyptr q, int16_t height);

extern void quoly_mod_and_quot(quolyptr n, quolyptr m);

extern void generalized_degree(quolyptr qp, quolyptr n, int32_t level, Boolean lowest);

extern Boolean negexponents(workptr ar, int32_t m);

extern void quoly_field_leading_coef(quolyptr x, quolyptr n);  /* Aug 1997 */

extern void polylist(textptr outt, Boolean saveflag);

extern void make_muldata(polyptrr muldata, polyptrr r, int32_t expon, polypt q);

extern void matrix_mult(workptr arr, workptr arr2, arr_descr *arrf, arr_descr *arr2f, Boolean 
     arr_free, sparseptr *spar, sparseptr *spar2);

extern void matrix_power(workptr arr, arr_descr *arr_facts, Boolean *arr_free, int32_t expont, sparseptr *spar);

extern void alt_mat_power(workptr arr, arr_descr *arr_facts, Boolean *arr_free, int32_t expont);

extern void matpowermod(workptr arr, arr_descr *arr_facts, Boolean *arr_free, imptr expont, 
     quolyptr modder, Boolean showit);

extern void sparse_gauss_elim(sparseptr spar, quolyptr n, int32_t m, int32_t mycut, Boolean ar_free);

extern void Mills(arrptr q, int32_t rows, int32_t slow, quolyptr bound, quolyptr n, Boolean *succeed);

extern void phaseone(boolarray *want, workptr alpha, workptr beta, workptr alphinv, workptr betinv, 
     Longiptr min, int32_t rows, int32_t cols, int32_t init, int32_t start, int32_t stop, Boolean *flipped, Boolean 
     wantrows, Boolean wantmod, Boolean wanthalf, imptr pseudodet, imptr halfpseudo);

extern void add_sparses(sparseptr *spar, sparseptr *spar2, Boolean arr_free, Boolean arr2_free, 
     int32_t row, Boolean plus);

extern void mult_sparses(sparseptr *spar, sparseptr *spar2, int32_t rows1, int32_t rows2, int32_t cols2, 
     Boolean arr_free);

extern void mult_sparse_norm(sparseptr *spar, workptr arr2, workptr arr, Boolean spar_free, 
     int32_t rows1, int32_t rows2, int32_t cols2, arr_descr *arrf);

extern void mult_cons_sparse(sparseptr *spar, quoly n2, Boolean free, int32_t row);

extern void fast_mat_mult(workptr arr, workptr arr2, workptr z, int32_t rows1, int32_t rows2, int32_t cols2);

extern void sparse_great_abs(sparseptr *spar, int32_t rows, Boolean free, Boolean abs);

extern void adjoint(workptr alpha, workptr arr, Boolean alpha_free, int32_t m, sparseptr *spar);

extern void extract_diagonal(workptr arr, workptr arr2, arr_descr *arr_facts, Boolean arr_free, 
     Longiptr rows, sparseptr *spar);

extern void reconcile_gcd_lists(polypt q);

extern void make_and_reconcile_gcd_lists(polypt q);

extern void mod_determ(workptr ar, int32_t m, quolyptr n);

extern void sparse_mod_int_determ(quolyptr n, sparseptr *spar, int32_t rows, Boolean arrfree, Boolean myverb); /* Mar 2004 */

extern Boolean sparse_lagrange(sparseptr spar, quolyptr n, int32_t m, poly fct, int32_t the_degree, int32_t the_degree2, int32_t the_degree3,
                              int32_t the_power, Boolean really, int32_t numprimes);    /*Dec 2005. Jan 2008. Oct 2009 Jan 2021 */

extern void sparse_gauss_Bareiss(sparseptr spar, quolyptr n, int32_t m, int32_t mycut, Boolean ar_free); /* Mar 2004 */

extern Boolean mod_poly_determ(workptr ar, int16_t polydepth, int32_t m, quolyptr q, Boolean check_laurent, 
     poly fct, int32_t the_degree);  /* Apr 2001 */

extern Boolean rat_poly_determ(workptr ar, int16_t polydepth, int32_t m, quolyptr q, Boolean check_laurent, 
     poly fct, int32_t this_deg);

extern void invert_sparse(sparseptr *spar, workptr arr, Boolean ar_free, Boolean invert, int32_t rows, quolyptr n);

extern Boolean mod_matrix_inv(workptr ar, workptr outar, Boolean oar_free, int32_t m, quolyptr det, 
     quolyptr pseudodet, sparseptr *spar, Boolean inverse);

extern void sparse_mod_or_div(sparseptr *spar, quoly n2, int32_t row, Boolean free, char which);

extern void sparse_mod_rowreduce(quolyptr n, sparseptr spar, Boolean pseudo, boolarray *want, int32_t rows, int32_t cols, 
                                 workptr alpha, spar_arr *auxspar, int32_t start, int32_t cut); // Aug 2018

extern void colreduce(quolyptr n, arrptr q, boolarray *want, workptr alpha, workptr beta, workptr alphinv, workptr 
                      betinv, spar_arr *auxspar, Boolean pseudo, int32_t cut, int32_t startpos);  // Aug 2018

extern void sum_arr(workptr arr, int32_t m, quolyptr n);

extern void compute_char_poly(int32_t n, int32_t i, quolyptr q);

extern void add_one_sparse(workptr arr, arr_descr *arr_facts, Boolean spar_free, sparseptr spar, Boolean plus);

extern void mod_Mills(sparseptr q, int32_t rows, int32_t slow, ymills *y, polyptrr qlast);

extern void fill_sparse(arrptr q);

extern void sparse_sum(quolyptr n, sparseptr spar, int32_t rows);

extern void sparse_max_min(sparseptr spar, int32_t rows, int32_t cols, Boolean max, Boolean pos_only, quolyptr n);

extern void set_up_hamilton(workptr arr, arr_descr *arrf, Boolean *arr_free, sparseptr *spar);

extern int32_t rand_integer(void); /*added AAR*/

extern void recheck(quolyptr p); /*added AAR*/

extern void quoly_set_lint(int32_t num, quolyptr p); /*added AAR */

extern void make_p_roots(polypt pt); /*added AAR*/

extern void check_for_pth_roots(void); /*added AAR*/

extern void random_poly(polyptrr p, polyptrr q, int32_t deg, int32_t level); /*added AAR*/

extern void sparse_trace(quolyptr n, sparseptr spar, int32_t rows); /*added AAR*/

extern void reverse_array(arrptr q);    /* Apr2 2011 */

extern void reverse_sparse(sparseptr *spar, int32_t rows);    /* Apr2 2011 */

extern void arr_to_poly(arrptr q, quoly *n);    /* Apr2 2011 */

extern void arr_to_poly_sparse(sparseptr spar, int32_t rows, quoly *n);    /* Apr2 2011 */

extern void spec_general_quoly_add(quoly n, quoly m, quolyptr q, Boolean add);   // Nov 2016

extern void old_expre(textptr inf, quolyptr n, nameptr *flag);   // moved here Aug 2018

extern poly total_degree_equal(poly p, int32_t level, int32_t deg, do_total_degree_EnvRec *do_total_degree_Env);  // Dec 2021 Oct 2022

extern void horner_quoly_eval(quolyptr n, quolyptr n2, int32_t target);   // Dec 2021

#endif
