#ifndef FER320_H
#define FER320_H 


/*  Fermat 64 bit computer algebra system for Linux.
    Copyright (C) 2020 Robert H. Lewis.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

#include "ferm120.h"
/*
#include <Types.h>
#include <QuickDraw.h>
#include <Events.h>
#include <OSUtils.h>
#include <Files.h>
#include <Devices.h>
#include <DeskBus.h>
#include <DiskInit.h>
#include <Disks.h>
#include <Errors.h>
#include <Memory.h>
#include <Retrace.h>
#include <SegLoad.h>
#include <Serial.h>
#include <Shutdown.h>
#include <Slots.h>
#include <Sound.h>
#include <Start.h>
#include <Timer.h>
#include <Events.h>
#include <Controls.h>
#include <Desk.h>
#include <Windows.h>
#include <TextEdit.h>
#include <Dialogs.h>
#include <Fonts.h>
#include <Lists.h>
#include <Menus.h>
#include <Resources.h>
#include <Scrap.h>
#include <ToolUtils.h>
#include <FCntl.h>
#include "sane.h"
*/

extern int32_t palloc;  /* Aug 2003 */

extern unsigned char prompt [11];                 /* May 2003 */
extern unsigned char eprompt [11];                /* Jul 2003 */
extern char trash;                                /* May 2003 */
extern char continuation;
extern bigstring input_file_name;                 /* May 2003 */
extern bigstring output_file_name;
extern bigstring blankone;
extern polypt polynames;                          /* nilpol is always nil, pseudo_polynames is 
                                                     nil unless there is actually need for poly-
                                                     mod-out, when it is polynames.   always?
                                                     It is used to simplify poly_mult. */

extern uint64_t memavail(void); /*AAR*/    /* Oct2 2010 */ 
extern uint64_t totalavailablememory;      /* Oct2 2010 */

extern tokentipe blank;   // Nov 2018.  moved here

extern polypt old_polynames;
extern polypt nilpol;
extern polypt pseudo_polynames;
extern int32_t endarr;
extern int32_t first_available;
extern int32_t semicount;
extern int32_t smalldet;
extern int32_t smallsize;
extern int32_t sizeval;
extern int32_t mincutoff;
extern int32_t levelcount;
extern int32_t matrix_eval;
extern int32_t mills_mod;
extern int32_t randint;
extern int32_t limit_char_arrays;
extern int32_t two28_mod;
extern int32_t cntdepth;
extern int32_t cntcount;
extern int64_t g_cutoff;    // Sep 2015
extern int32_t number_polys;
extern int32_t emgcd_basic_cut;  /* Oct 2003 */
extern int32_t hgcd_cut;
extern int32_t size_data_strucs;
extern int32_t mod_method_diff;
extern int64_t gcdmass;  /* Oct2 2010 */
extern int32_t mod_det_method_cut;
extern int32_t gauss_cutoff;
extern int32_t rat_det_method_cut;
extern int32_t poly_cutoff;
extern int32_t monocut;     /* Aug 2013 */
extern int64_t big_monocut;  // Nov 2013
extern int32_t div_poly_cutoff;
extern int32_t suppressor;
extern nametype polyvar[max_number_polys];
/* 30 July 1998, May 2003 */
/* Jul 2002 */
extern Boolean integerflag;                       /* May 2003 */
extern Boolean errorpush;
extern Boolean laurent;
extern Boolean wanthalf_;
extern Boolean timerflag;
extern Boolean time_to_quit;
extern Boolean noisy;
extern Boolean doing_sys_func;
extern Boolean want_sparse;
extern Boolean pddummy;
extern Boolean watch_for_func;
extern Boolean chpoly_block;
extern Boolean uglyprint;
extern Boolean new_funcs;
extern Boolean new_array;
extern Boolean modout_above_field;

extern int16_t dispcutoff;                          /* May 2003 */

extern hampath number_col;                        /* for Hamiltonian path. Nov 1996 */
extern hampath colm_mass;
extern int32_t total_cnt;                            /* May 2003 */
extern int32_t lowcnt;
extern int32_t lagrangedepth;
extern int32_t lagrangecut;
extern int32_t detcutoff;

extern sparsedet sparse_number_col;  /* for Sparse Det Minors. Nov 1996 */
extern sparsedet64 sparse_mass;        // Oct2 2013: used only in fer221.c
extern int32_t sp_total_cnt;
extern int32_t sp_lowcnt;
extern int32_t minorprime;
extern uint64_t minor_memory;     /* Oct2 2010 */
extern int32_t minor_count;
extern int32_t init_max_stash;
extern int32_t init_min_stash;
extern int32_t minor_total;
extern int32_t min_stash_row;
extern int32_t max_stash_row;
extern int32_t init_max_stash_row;   /* Jun2 2009 */
extern int32_t purged_hits;
extern sparseptr minorstash;                      /* Feb 1997 */

extern test_array global_list;                    /* Nov 2001 */

extern quoly quol_num_0;                          /*spar*/
                                                  /* moved here May 2001 */
extern quoly quol_num_1;                          /* Nov 2003 */
extern quolynode global_quoly;                    /* Nov 2003 */

extern poly poly_1;    /* Dec 2003 */
extern gcd_ptr xx;       /* Jan 2004 */
extern gcd_ptr yy;
extern gcd_ptr zz;

extern gcd2_ptr x2;      /* May 2005 */
extern gcd2_ptr y2;
extern gcd2_ptr z2;

extern int32_t monolength;   /* Jul 2013. default 9 */
extern int32_t old_monolength;   /* Mar 2020.  for on-the-fly resetting of mono stuff */
extern int32_t mononum;      /* default 2^9 = 512 */
extern int32_t monovars;     /* default 14 */
extern int32_t monogap;      /* default 128 - 126 = 2 */
extern mono monogarb;        /* Jul 2013 */
extern mar_ptr smp1;          /* Aug 2013 */
extern mar_ptr smp2;          /* Aug 2013 */

extern hash_ptr htable;       /* Aug 2013 */
extern  __uint128_t big128;    /* Aug 2013 */
extern int32_t monowarn;      /* Sep 2013 */

extern int64_t tot_mono_cnt;   /* Oct2 2013 */
extern int64_t tot_mono_size;  /* Oct2 2013 */
extern int64_t tot_mono_pop;   /* Oct2 2013 */
extern int64_t tot_mono_rep;   /* Oct2 2013 */

extern heap_ptr heap;        /* Aug 2013 */

extern Boolean lagrange_stash;  /* Apr 2009 */

extern int32_t hashp[33]; /* Jun 2016 */

extern Boolean quoly_add_flag;   // Nov 2016

extern Boolean good_field;   // Nov 2016

extern tokentipe semicolon;  // May 2022

extern int32_t plugins[50];   // Feb 2023

extern void newpoly(polyptrr p);

extern void newquoly(quolyptr q);

 // extern void newpt(polypt *p);  Mar 2017.  this has been moved to ferm120.h

extern void newmono(monoptr p);    /* Jul 2013 */

extern void newdummy(polypt *s, polypt *pp3);

extern void free_pt(polypt *p);

extern void init_poly_node(poly p); /* Oct 2005.  was polyptrr; waste of time */

extern void init_quoly_node(quoly p); /* Oct 2005.  was quolyptr; waste of time */

extern void free_poly(polyptrr p);

extern void free_mono(monoptr p, mono tail);  /* Aug 2013 */

extern void lint_free_mono(monoptr p, mono tail);  /* Aug 2013 */

extern void free_poly_nodes(polyptrr p, int16_t depth);   /* Aug 2013  Feb 2023 */

extern void special_free_poly(polyptrr p);          /* Dec 2002 */

extern void special_print_poly(polyptrr p);   /* May 2008 */

extern void remove_dummy(poly u);

extern void doblanks(textptr outf, int32_t ind);    /* Jul 2003 */

extern void free_quoly(quolyptr q);

extern void poly_inplace(poly p);

extern void quoly_inplace(quoly p);

extern poly lastnum(poly n);

extern poly lastnode(poly n);

extern int32_t poly_numterms(poly n, int16_t depth);   /* Jul 2003 */

extern int32_t qpoly_numterms(poly n, int16_t depth);  /* Mar 2006 */

extern int32_t q2poly_numterms(poly n, int16_t depth);  /* Mar 2020 */

extern int32_t poly_weight(poly n, int32_t depth);  /* Jan 2008 */

extern int32_t quolyhash(quolyptr q);  /* Jun 2013. added here Dec 2016 */

extern int32_t f_poly_numterms(poly n);             /* Dec 2003 */

extern int32_t q_poly_numterms(poly n);       /* Mar 2013 */

extern int32_t numterms(quoly n);                    /* Oct 1996 */

extern int32_t q_numterms(quoly n);          /* Jun 2008 */

extern int32_t f_numterms(quoly n);                  /* Jul 2003 */

extern int16_t poly_nodes(poly n);                  /* Oct 2002 */

extern int64_t new_poly_mass(poly n, int32_t depth);    /* Mar 2008. Apr 2011 */

extern int32_t very_simple_poly_mass(poly n);   /* put here Oct 2010 */

extern void mono_assign(mono p, monoptr q, monoptr qt);  /* Aug 2013 */

extern void poly_assign(poly p, polyptrr q);

extern void spec_poly_assign(poly p, polyptrr q);

extern void node_assign(poly p, polyptrr q);

extern void quoly_assign(quoly p, quolyptr q);

extern void mod_quol_assign(quoly p, quolyptr q);

extern void quoly_to_poly(quoly q, polyptrr p);

extern void poly_to_quoly(poly p, quolyptr q);

extern void p_q_assign(poly p, quolyptr q);

extern void polynum_to_quoly(quolyptr q);

extern void get_char_poly(int16_t i, int16_t j, quolyptr q);

extern void decr_dumpitt(int32_t n, Boolean newline, Boolean multin);  /* Sep 1996. Mar 2004 */

extern void findHeight(polyptrr n, polyptrr m, PASCALPOINTER h, polypt *pt);

extern void max_degree(poly q, int32_t lev, Longiptr ans);

extern Boolean first_coef_invrtble(poly q, int16_t depth);

extern Boolean invertible_coef(poly q, polypt pt);

extern int32_t sizepoly(poly p);                     /* Jul 2001 */

extern void garbage(char x);

extern void restore_from_mod(fixptr *fx);

extern void poly_makeneg(poly p, polyptrr q);

extern void quoly_makeneg(quoly p, quolyptr q);

extern void restore_sparsefix(void);   // Jun 2016

extern Boolean quoly_mon_less(quoly p, quoly q); /* Sep 2010. move here Jun 2016 */

extern Boolean quoly_mon_less_eq(quoly p, quoly q); /* Sep 2010 */

extern Boolean mon_less(poly p, poly q, Boolean *equal); /* Jul 2006. move here Jun 2016 */

extern void scalar_to_poly(imptr n, polyptrr p);

extern void scalar_to_quoly(imptr n, quolyptr p);

extern void spec_scalar_quoly(imptr n, quolyptr p);  /* Oct 2000 */

extern void poly_set(int32_t num, polyptrr p);

extern void quoly_set(int32_t num, quolyptr p);

extern void free_colm(colm_ptrptr t);               /* moved July 1998 */

extern void newname(nameptr *p);                    /* moved May 2003 */

extern void get_sparse_colm(sparseptr sp, int32_t r, int32_t c, colm_ptrptr *t);  /* August 1996 */

extern quolyptr get_sparse(int32_t r, int32_t c, colm_ptrptr *t, sparseptr *isp);
/* August 1996; Nov 2000 */

extern void standard_to_sparse(arrptr q, workptr arr, int32_t cols, Boolean arr_free);

extern void purge_sparse(colm_ptrptr t, int32_t c);    /* Nov 1997 */

extern void sparse_zero_set(colm_ptrptr t, int32_t c, quolyptr *qp);  /* Nov 1997 */

extern void isparse_insert(int32_t r, int32_t c, int32_t n, arrptr q, Boolean colflag, Boolean assign);
/* Nov 1997 */

extern void leading_term(quoly q, quolyptr n);      /* Nov 1997 */

extern void sparse_set(int32_t r, int32_t c, arrptr q, quolyptr *qp, Boolean colflag);  /* Dec 1997 */

extern void quick_sparse_create(sparseptr sp, tokentipe *let, int32_t r, int32_t c, Boolean liner);  /* Nov 2000 */

extern void sparse_insert(int32_t r, int32_t c, arrptr q, Boolean colflag, quolyptr n);  /*@@@*/

extern void sparse_delete(int32_t r, int32_t c, arrptr q, Boolean colflag);  /*@@@*/

extern void sparse_iszero(sparseptr spar, int32_t rows, Longiptr ans);  /*@@@*/

extern Boolean sparse_allpolys(sparseptr sp, int32_t rows, Boolean *allnumbs);  /* Mar 2004 */

extern Boolean sparse_allnumbs(sparseptr sp, int32_t rows);  /* Nov 2000. */

extern int16_t sparse_polydepth(sparseptr sp, int32_t rows);  /* Feb 2004 */

extern void move_data_into_quoly(sparseptr sp, int32_t rows);  /* Nov 2000. */

extern void move_data_outof_quoly(sparseptr sp, int32_t rows);  /* Nov 2000. */

extern void put_back_sparse(sparseptr dup, sparseptr spar, int32_t rows);  /* Nov 2000. */

extern int64_t row_mass(colm_ptr t);                 /* Nov 1996  Oct2 2013 */

extern int32_t quick_row_mass(colm_ptr t);           /* Nov 1996 */

extern Boolean depth_only_2(poly u);              /* Oct 2002 */

extern void remove_col(sparseptr spar, int32_t k, int32_t dim, imptrptr w, polyptrr nu);  /* Nov 1996.  Jun 2010: fer64*/

extern void restore_col(int32_t k, imptr w, polyptrr nu);  /* Nov 1996. Jun 2010: fer64 */

extern void ham_remove_col(sparseptr spar, int32_t k, int32_t dim, imptrptr w);  /* Nov 1996 */

extern int32_t minorshash(imptr md);                 /* Feb 1997 */

extern int32_t minorsize(int32_t n);                    /* Feb 1997 */

extern Boolean minor_is_there(imptr md, int32_t addr, quolyptr n);  /* Feb 1997 */

extern Boolean int_minor_is_there(imptr md, int32_t addr, Longiptr n);  /* Jul 1999 */

extern void stash_minor(imptr md, int32_t addr, quolyptr n);  /* Feb 1997 */

extern void int_stash_minor(imptr md, int32_t addr, int32_t n);  /* Jun 1999 */

extern void free_minor_stash(int32_t size, Longiptr count, Longiptr hits);

extern void count_minor_stash(Longiptr count, Longiptr hits);

extern void free_minor_data(imptr md);              /* Feb 1997 */

extern void update_col_list(imptr md, int32_t index, lintptr spot, numptrptr p);
/* Feb 1997, Nov 2000   changed to intptr from PASCALPOINTER  Mar 2005. no more ints, Jun 2010 */

extern void update_row_list(imptr md, int32_t index, lintptr spot, numptrptr p);
/* Feb 1997, Nov 2000   changed to intptr from PASCALPOINTER  Mar 2005.  no more ints, Jun 2010 */

extern void ham_restore_col(int32_t k, imptr w);      /* Nov 1996 */

extern void remove_row(sparseptr spar, int32_t row, int32_t k, colm_ptrptr u);  /* Nov 1996 */

extern void ham_remove_row(sparseptr spar, int32_t row, int32_t k, colm_ptrptr u);  /* Nov 1996 */

extern void restore_row(sparseptr spar, int32_t row, int32_t k, colm_ptr u);  /* Nov 1996 */

extern void ham_restore_row(sparseptr spar, int32_t row, int32_t k, colm_ptr u);  /* Nov 1996 */

extern int32_t permute(colptr cp, int32_t i);           /* August 1996 */

extern Boolean pos_leading_coef(poly p);

extern Boolean neg_leading_term(poly n);

extern int32_t convert_to_int(imptr n);

extern int32_t quoly_convert_to_int(quoly p);

extern int32_t big_quoly_convert_to_int(quoly p);  /* Dec 2005 */

extern Boolean do_mod_method_now(poly u, poly v, int32_t mod_deg, Boolean tried_modular);

extern Boolean mod_do_Chinese(poly u, poly v, int32_t mod_deg);

extern int32_t poly_length(poly n);

extern int32_t exp_poly_length(poly n, Longiptr expon, Boolean *one_var);  /* Oct 2003 */

extern int16_t fast_poly_length(poly n, int16_t cut);

extern int16_t fast_f_numterms(poly n, int16_t depth);		/* Jan 2006 */

extern int32_t poly_level(poly n);

extern int32_t driver_poly_vars(poly n);    /* Jan 2010 */

extern void poly_level_depth(int16_t ulevel, int16_t vlevel, int32_t total, intptr lev, intptr depth); /* Feb 2006 */

extern int16_t fast_numterms(poly n);               /* Nov 2002 */

extern int16_t node_total(poly n);                  /*!!*/

extern int16_t new_node_total(poly n);      /* Jun 2005 */

extern int16_t big_node_total(poly n);              /* Dec 2001 */

extern int16_t expon_node_total(poly n, int32_t depth, Boolean init, int64_t *expop);  /* Dec 2005   Nov 2013 */

extern int32_t b_expon_node_total(poly n, int32_t depth, Boolean init, int64_t *expop);  // Sep2 2015

extern int32_t bigger_node_total(poly n);            /* Dec 2001; Nov 2002 */

extern int32_t new_bigger_node_total(poly n);  // Apr 2020

extern int32_t bigg_node_total(poly n);  /* Feb 2006 */

extern void sub_expons(poly u, polyptrr utail, int32_t uexp);  /*!!*/

extern void restore_exps(poly u, poly utail, int32_t uexp);  /*!!*/

extern int32_t prod_num_size(poly n, poly m);        /* Jul 2001 */

extern int32_t prod_size(poly n, poly m, Boolean toplevel);  /* Jul 2001 */

extern int64_t poly_mass(poly n, int32_t multplier, int32_t depth);  // Oct 2013

extern int64_t full_poly_mass(poly n, int32_t multplier, int32_t depth);   // Oct 2013

extern int64_t better_poly_mass(poly n, int32_t multplier, int32_t depth);  // Jun 2016.  Why was this not put here in Oct 2013?

extern int64_t best_poly_mass(poly n, int32_t depth);  // Jun 2016

extern int32_t simple_poly_mass(poly n);

extern int64_t quoly_mass(quoly n);   // Oct 2013

extern void poly_to_scalar(poly p, imptr n);

extern Boolean poly_small(poly n);

extern Boolean monomial(poly n);

extern void make_monomial(polyptrr p, int32_t expo, poly cf);

extern int32_t rand_integer2(void);

extern int32_t rand_integer3(void);

extern void random_field_element(polyptrr q, int16_t height, polypt pt);

extern void gcdhash(poly u, poly v, polyptrr pr);

extern void free_gcd_stash(int32_t source);  // May 2020

extern void sure_free_gcd_stash(void);  // Jun 2016

extern void init_gcd_stash(void); /* Dec 2003 */

extern Boolean is_array_param(quoly p);

extern Boolean is_poly_name(nametype *x, Longiptr depth);

extern Boolean is_poly_var(quoly n, Longiptr depth);  /* July 2002 */

extern Boolean its_a_polyname(nametype *x);

extern void is_poly_name2(nametype *x, Longiptr depth, polypt *q);

extern void delete_poly_name(int32_t depth);

extern void remove_poly_var(quolyptr q, int32_t depth);

extern void base_poly(polyptrr p, int32_t depth);

extern void base_quoly(quolyptr p, int32_t depth);

extern Boolean poly_equal(poly p, poly q);

extern Boolean poly_neg(poly p, poly q);          /* Jul 2002, moved here */

extern Boolean essentially_equal(poly p, poly q);

extern Boolean quoly_equal(quoly p, quoly q);

extern Boolean quoly_negtive(quoly p, quoly q);   /* Sep 2000*/

extern Boolean poly_iszero(poly p);

extern Boolean node_iszero(poly p);

extern Boolean lint_quoly_iszero(quoly p);  /* Jun 2006 */

extern Boolean quoly_iszero(quoly p);

extern Boolean poly_eq_1(poly p);

extern Boolean poly_eq_m1(poly p);

extern Boolean quoly_eq_1(quoly p);

extern Boolean quoly_eq_m1(quoly p);              /* Jul 2002*/

extern Boolean quol_neg_lead_term(quoly n);

extern Boolean quoly_larger(quoly p, quoly q);

extern int16_t poly_depth(poly p);

extern int32_t real_degree(poly p, int16_t polydepth);  /* Mar 2004 */

extern int32_t real_q_degree(quoly q, int16_t polydepth);  /* Mar 2004 */

extern int32_t zipcount;   // Sep2 2016

extern Boolean height_is_1(poly n);

extern poly leading_coef(poly n);

extern void quoly_consume(quolyptr n, polyptrr p);

extern void poly_change_from_mod(poly p);

extern void special_poly_change_from_mod(poly p);  // Jun 2014

extern void poly_to_prime(poly n);

extern void dump_mons(arrptr q, quoly n, Boolean strip);  /* Aug 1997; Aug 2002 */

extern void dump_exps(arrptr q, quoly n, int32_t k);   // Jan 2016 Jan 2023

extern void quoly_change_from_mod(quoly q);  /* Sep 2004 */

extern void special_quoly_change_from_mod(quoly q);  /* Jun 2014 */

extern void insert_new_prime(int32_t this_prime, int32_t x, imptrptr ii);  /* May 1998 */

extern void add_prime_to_list(polypt q, int32_t thisone, int32_t x);

extern void add_all_to_list(polypt q, int32_t x, imptr y);

extern void poly_consume(polyptrr n, quolyptr q);

extern void use_up_poly(polyptrr n, quolyptr q);   /* Oct 2003 */

extern void rat_number_mult(poly n, imptr im);

extern void simple_quot(imptr n1, imptr n2, int32_t x);  /* Oct 2009 */

extern void num_poly_quot(poly n, imptr m, int32_t x);

extern void mod_num_poly_mult(poly n, int32_t x);

extern void fast_mod_num_poly_mult(poly n, int64_t x);   /* Nov 2010 */

extern void num_poly_mult(poly n, imptr m);

extern void monic_coefs(poly u, poly v, Longiptr ucoef, Longiptr vcoef);

extern Boolean nogood(poly u, int16_t depth, int16_t test_depth);

extern Boolean all_coefs_invrtble(poly u, int16_t depth);  /* moved here May 2003 */

extern Boolean all_coefs_invrtble_both(poly u, poly v, int16_t depth);  /* moved here May 2003 */

extern Boolean is_prime(int32_t x);

extern int32_t long_is_prime(int32_t x);  /* Sep 2008 */

extern uint32_t longg_is_prime(int32_t x0, int32_t x1, int32_t x2);  /* Sep 2008 */

extern void prime_factors(int32_t x, numptrptr np);

extern void set_prime_quotients(numptrptr qp, int32_t n);

extern Boolean cant_factor(poly q, Longiptr errno, Boolean check_below, int16_t *code, int16_t *dpth, int16_t *lower_depth);
   // Nov 2021

extern void find_gcdcoefs(poly p, imptr com);

extern void free_gcd_data(polypt q);

extern int16_t imaxx(int16_t a, int16_t b);

extern int16_t depth_below(poly p);

extern void copy_syst(workptr arr, int32_t rows, sparseptr *spar);  /* Nov 1997 */

extern int16_t poly_height(poly p);

extern int32_t mod_mult(uint32_t x, uint32_t y, int32_t modul); /* Apr 2004 */

extern int32_t mod_add(uint32_t x, uint32_t y, int32_t modul); /* Apr 2004 */

int32_t spec_mod_add(uint32_t x, int32_t y, int32_t modul); /* Apr 2004 */

extern int32_t mod_sub(int32_t x, int32_t y, int32_t modul); /* Apr 2004 */

// extern int32_t modmult(uint32_t x, uint32_t y);      Apr 2004    moved out Sep2 2016 */

extern int32_t spec_modmult(uint32_t x, uint32_t y);   /* Apr 2004 */

extern void verse(Longiptr ans);

extern void initialize(char *);

extern Boolean doing_polymod_field(void);

extern void newcolm(colm_ptrptr q);

extern void switchrow_col(int32_t index, int32_t j, int32_t k, int32_t start, int32_t total_rows, int32_t target_rows, int32_t cols);

extern void int_col_manip(int32_t j, int32_t k, int32_t start, int32_t rows, imptr factor);

extern void reduce_it(imptr m, imptr pseudodet, imptr halfpseudo, Boolean wanthalf);

extern void int_col_neg(int32_t j, int32_t k, int32_t start, int32_t rows);

extern void int_arr_col_neg(workptr arr, int32_t j, int32_t rows);

extern void int_row_neg(int32_t j, int32_t k, int32_t start, int32_t rows, int32_t cols);

extern void int_arr_row_neg(workptr arr, int32_t j, int32_t rows, int32_t cols);

extern void sp_row_neg(int32_t j, sparseptr sp);

extern void sp_col_neg(int32_t j, int32_t start, int32_t rows, sparseptr sp);

extern void poly_to_array(int32_t rows, int32_t start, polyptrr p);

extern void fillup(int32_t rows, int32_t cols, int32_t start, workptr arr);

extern void sp_switchrow(sparseptr sp, int32_t i, int32_t j);

extern void sp_switchcol(sparseptr sp, int32_t i, int32_t k, int32_t rows, int32_t start);

extern void intfindbest(int32_t start, int32_t stop, int32_t rows, int32_t i, Longiptr j,  Longiptr k, Longiptr val);

extern void sparse_intfindbest(sparseptr sp, int32_t rows, int32_t i, Longiptr j, Longiptr k, Longiptr val);

extern void sparse_best_diag(sparseptr sp, int32_t rows, int32_t i, Longiptr j, Longiptr val);

extern void sparse_findbest(Boolean leave_early, sparseptr sp, int32_t rows, int32_t i, Longiptr j, Longiptr k);

extern void mod_sparse_findbest(Boolean leave_early, sparseptr sp, int32_t rows, int32_t i, Longiptr j,  Longiptr k);

extern void special_mod_sparse_findbest(Boolean leave_early, sparseptr sp, int32_t rows, int32_t i, Longiptr j, Longiptr k);

extern void spec2_mod_sparse_findbest(sparseptr sp, int32_t i, Longiptr k);
/* Feb 2005 */

extern Boolean spec1_mod_sparse_findbest(sparseptr sp, int32_t rows, int32_t i, Longiptr j, Longiptr k);
   /* Feb 2005 */

extern void findbest(int32_t start, int32_t stop, int32_t rows, int32_t i, Longiptr j, Longiptr k, Boolean firstonly);

extern void free_stuff(sparseptr spar, int32_t row );

extern void colfindbest(int32_t start, int32_t rows, int32_t i, int32_t col, Longiptr j  /* Oct 2000 */ );

extern void sparse_colfindbest(sparseptr sp, int32_t rows, int32_t i, int32_t col, Longiptr j  /* Nov 2000 */  );

extern void sparse_mod_colfindbest(sparseptr sp, int32_t rows, int32_t i, int32_t col, Longiptr j);
/* Nov 2000 */

extern void free_sparse(sparseptr *spar, int32_t dim, Boolean arr_free);

extern void free_sparse_frame(sparseptr *spar, int32_t dim);

extern void copy_sparse(sparseptr *s, sparseptr *t, int32_t dim, Boolean neg);

extern void copy_sub_sparse(arrptr q, sparseptr *t, int32_t firstrow, int32_t firstcol, int32_t rows, int32_t cols); // Apr 2016

extern void special_copy_sparse(sparseptr s, sparseptr *t, int32_t dim); /* Apr 2004 */

extern void spar_identi(sparseptr *spar, int32_t rows, Boolean arr_free);

extern void flip_sparse(sparseptr *spar, sparseptr *spar2, int32_t row,   /* moved July 1998 */
                        int32_t col);

extern void trans_sparse(sparseptr *spar, int32_t row,   /* moved July 1998 */
                         int32_t col);

extern void sparse_set_scalar(arrptr q, int32_t cols, quoly n);

extern void sparse_init(sparseptr *spar, int32_t r);

extern void sparse_makeneg(sparseptr *spar, int32_t rows, Boolean *arr_free);

extern void swap_rows(quolyptr n, workptr dup, Boolean want_n, Boolean do_all, int32_t i, int32_t j, int32_t m);

extern void spec_swap_rows(workptr dup, int32_t i, int32_t j, int32_t rows);

extern void swap_cols(workptr arr, int32_t i, int32_t j, int32_t rows);

extern void identi(workptr arr, int32_t rows, Boolean arr_free);

extern void uppertri(workptr arr, int32_t rows);

extern void best_on_diag(int32_t start, int32_t stop, int32_t rows, int32_t i, Longiptr j, Longiptr val);

extern void best_other(int32_t start, int32_t stop, int32_t i, int32_t rows, Longiptr j);

extern void row_red_arr(workptr arr, imptr factor, int32_t rows, int32_t k, int32_t q);

extern void col_red_arr(workptr arr, imptr factor, int32_t rows, int32_t k, int32_t q);

extern void int_rowreduce(int32_t start, int32_t i, int32_t j, int32_t k, int32_t t, int32_t rows, int32_t stop, Longiptr j2,   /* July 1998 */ Longiptr k2, Longiptr val2, Boolean wantsmallest, imptr factor, Boolean wantmod, Boolean wanthalf, imptr pseudodet, imptr halfpseudo);

extern void int_colreduce(int32_t start, int32_t i, int32_t j, int32_t k, int32_t t, int32_t rows, Longiptr j2, Longiptr k2, Longiptr val2, Boolean wantsmallest, imptr factor, Boolean wantmod, Boolean wanthalf, imptr pseudodet, imptr halfpseudo);

extern void sparse_int_rowred(sparseptr sp, colm_ptrptr t, colm_ptrptr u, int32_t j, int32_t k, int32_t tg, int32_t rows, Longiptr 
      j2, Longiptr k2, Longiptr val2, Boolean wantsmallest, imptr factor, Boolean wantmod, Boolean wanthalf, imptr 
      pseudodet, imptr halfpseudo);  /* July 1998 */

extern void sparse_int_colred(sparseptr sp, int32_t init, int32_t j, int32_t k, int32_t tg, int32_t rows, Longiptr j2, Longiptr k2, 
         Longiptr val2, Boolean wantsmallest, imptr factor, Boolean wantmod, Boolean wanthalf, imptr pseudodet, 
         imptr halfpseudo);   /* June 1998 */

extern void sparse_mod_col_add(sparseptr sp, int32_t factor, int32_t rows, int32_t k, int32_t q);

extern void sparse_mod_row_add(sparseptr sp, int32_t factor, int32_t k, int32_t q);

extern void sparse_mod_divide_row(sparseptr sp, int32_t factor, int32_t k);

extern void sparse_mod_mult_col(sparseptr sp, int32_t factor, int32_t rows, int32_t k);

extern void fast_colreduce(int32_t start, int32_t j, int32_t k, int32_t t, int32_t rows, Longiptr j2, Longiptr k2, Longiptr 
      val2, imptr factor);

extern void fast_sparse_colred(sparseptr sp, int32_t init, int32_t j, int32_t k, int32_t tg, int32_t rows, Longiptr j2, Longiptr 
     k2, Longiptr val2, imptr factor);

extern void sparse_best_other(sparseptr sp, int32_t i, int32_t rows, Longiptr j );

extern int32_t size_of(int32_t value, int32_t size);

extern int32_t disper(int32_t n);                       /* July 1998 */

extern int16_t hash(nametype *x, int16_t prime);

extern void add_pad(polyptrr r, int16_t h);           /* moved Mar 2003 */

extern void eliminate_bads(polyptrr p, polyptrr exps, int32_t factor);  /* moved Mar 2003 */

extern void clear_bads(polyptrr p, polyptrr exps, polyptrr tail, int32_t value, int16_t depth); /* moved Mar 2003 */

extern void put_poly_disk(poly p);                 /* Jul 2001 */

extern void get_poly_disk(polyptrr p);             /* Jul 2001 */

extern void sort_vars(sort_ptr q, int16_t size);      /* Jul 2002 */

extern void killdenoms(sparseptr spar, int32_t spot, int32_t total_rows, int32_t target_rows, int32_t cols);  /* Jul 2002 */

extern int16_t quick_depth_below(poly p, int32_t depth) ; /* Oct 2010 */       /* moved here May 2003 */

extern Boolean both_above_field_depth(poly u, poly v, int16_t depth);  /* moved here May 2003 */

extern int32_t fastestlookup(tokentipe *x, arrptr *q);  /* moved here May 2003 */

extern quoly spar_retrieve(sparseptr sp, int32_t r, int32_t c);  /* moved here May 2003 */

extern poly field_leading_coef(poly q, polypt pt, polypt *pt2);  /* moved here May 2003 */

extern Boolean anynegs(poly p);                   /* moved May 2003 */

extern Boolean negexponents(workptr ar, int32_t m);   /* Oct 2003 */

extern Boolean sparse_negexponents(sparseptr sp, int32_t m);   /* Oct 2003 */

extern int32_t exp_poly_length(poly n, Longiptr expon, Boolean *one_var); /* Oct 2003 */

extern int16_t select_prime(poly x, poly y, int16_t buffer, int16_t rand_mod, int16_t prmesize, primeptr prme);  /* moved May 2003 */

extern void mult_num(poly x, imptr nm);           /* moved May 2003 */

extern void int_mult(imptr n, imptr m, imptr q);

extern void mod_mult_num(poly x, int32_t nm);          /* moved May 2003 */

extern void arrdescribe(textptr outf, arrptr p);    /* moved May 2003 */

// extern void eglobal_dump(void);   remove Mar 2014; unused

extern void listpars(textptr outf, paramptr p, Longiptr ind);  /* moved May 2003 */

extern void disp128(__uint128_t val); //extern void disp128(unsigned __int128 val);  /* Jul 2013 */

extern void showint(textptr outf, imptr y, Boolean flag, Boolean zeros_flag, Boolean base10_flag, Boolean indent_flag, 
    Boolean extra_space, Boolean outf_is_tty, Longiptr mylength);

extern void display(textptr outf, Boolean outf_is_tty, Boolean flag, imptr a, Longiptr mylength, Boolean extra_space);

extern poly leading_coef_level_two(poly p);

extern void restore_modular(Boolean modular_stuff);

extern void check_modular(Boolean *modular_stuff);

extern void set_min_cut(int32_t rows);

extern /*extended*/ double fsmallsize(int32_t r);

extern void fluff_out(polyptrr t, int32_t expon);

extern void egcd_ints(Longiptr n, int32_t m, Longiptr x, Longiptr y);   /* Jul 2004 */

extern void clean_up_colm();  /* Jul 2004 */

extern void clean_up_poly();  /* Jul 2004 */

extern void clean_up_quoly();  /* Jul 2004 */

extern void clean_up_imp();  /* Jul 2004 */

extern int32_t clean_degree(poly u, int16_t pd);  /* Jul 2004, Sep 2006 */

extern void nozero_copy_sparse(sparseptr *sp, int32_t rows, int32_t *newrows);   // Apr2 2016

extern void one_var_copy_sparse(sparseptr *s, sparseptr *t, int32_t dim);  /* Jul 2004 */

extern Boolean all_coefs_numb(poly u, lintptr dpth);  /* Jul 2004 */

extern Boolean sparse_one_var_polys(sparseptr sp, int32_t rows);  /* Jul 2004 */

extern void mult_expons(poly p, int32_t n);  /* Feb 2005 */

extern void mini_copy(poly p, polyptrr q);  /* May 2005 */

extern int32_t nextprime(int32_t x);   /* Mar 2009 */

extern uint32_t garbsize();   /* Jun2 2009 */  

extern int32_t fast_garbsize();   /* Jun2 2009 */ 

extern uint32_t big_garbsize();  /* Jun3 2009 */
 
extern int32_t med_garbsize();   /* Jun2 2009 */  

extern int32_t sum_degrees(poly p, int32_t depth, int32_t stop);  /* Aug 2009 */

extern void reset_cutoffs(int32_t newvalue);  /* Jan 2010 */

extern Boolean try_fast_2_var(poly u, poly v);  /* Jul 2010 */

extern void split_poly(quolyptr p, quolyptr m);  /* Aug 2010 */

extern void arraysort(workarray par, int32_t i, int32_t j, int32_t rows, int32_t cols) ;  /* Sep 2010 */

extern void sparse_arraysort(int32_t i, int32_t ii, int32_t j, int32_t ij);   /* Sep2 2010 */

extern void intarraysort(sparsered par, int32_t i, int32_t j);   // Mar2 2016

extern int32_t synth_union(arrptr q0, arrptr q1);  /* Oct 2010 */

extern int32_t synth_merge(arrptr q0, arrptr q1);  /* Oct 2010 */

extern int32_t intersect(arrptr q0, arrptr q1);    /* Oct 2010 */

extern int32_t synth_concat(arrptr q0, arrptr q1);  // Apr 2016

extern int16_t polys_there(poly p, int16_t depth);    /* Apr 2011 */

extern int64_t sparsity(poly n, int32_t *nterms, Boolean sub[], int32_t *max);   // Jun 2016, Aug 2016

extern void sparse_dup(sparseptr s, sparseptr t, int32_t dim);  // Sep 2016

extern void sparse_dup2(sparseptr s, sparseptr t, int32_t dim);  // Sep 2016

extern void free_stuff2(sparseptr spar, int32_t row);  // Sep 2016

extern int64_t polyhash(poly n, polypt pt);  // Jun 2016

extern int32_t nextp(int32_t *lrgp);   // Jul 2016, Aug 2016

extern void itrivial(int32_t n, int32_t r, Longiptr m);  // moved here Aug 2016

extern int32_t ifrom_table(int32_t n, int32_t r);  // moved here Aug 2016

extern void alt_lint_binom(int32_t n, int32_t r, Longiptr m); // Sep 2016

extern void alt_dump_mons(sparseptr sp, poly n, Boolean strip); // Sep 2016

extern int32_t zip_spar_2_retrieve(sparseptr sp, int32_t r, int32_t *coef);  // Sep 2016

extern void zip_spar_retrieve(sparseptr sp, int32_t r, int32_t *coef);   // Sep 2016

extern void zip_sparse_insert(int32_t r, int32_t c, sparseptr sp, int32_t n, int16_t source);  // Sep 2016, Jun 2017

extern quoly zip_spar_quoly(sparseptr sp, int32_t r);  // Sep 2016

extern Boolean poly_eq_pm1(poly p);  // Sep 2016

extern int32_t max_col_pop(sparseptr sp, int32_t rows);  // Sep 2016

extern void actual_synth_concat(sparseptr *ss, sparseptr s1, int32_t rows0, int32_t rows1, int32_t *cols0,
                            int32_t cols1, int32_t *k);  // Sep 2016

extern int32_t sparse_pop(sparseptr s, int32_t dim);   // Oct 2016

extern int32_t sizequoly(quoly q);  // Nov 2016, added here

extern int32_t synth_nonzero(arrptr q0, arrptr q1);   // Nov 2016

extern void actual_synth_nonzero(sparseptr *ss, sparseptr s1, int32_t rows0, int32_t rows1, int32_t *cols0,
                         int32_t cols1, int32_t *k);  // Nov 2016

extern colm_ptr get_colm(sparseptr sp, int32_t r);   // Nov 2016.

extern colm_ptrptr get_colm_ptr(sparseptr sp, int32_t r);   // Nov 2016.

extern int64_t density(sparseptr sp, int32_t rows);  // Dec 2016  Jan3 2017

extern void reverse(poly *q, poly *t);   //  Dec 2016

extern void sparse_free_row(sparseptr sp, int32_t r);   // Jan3 2017

extern void quolynum_to_poly(quoly q, polyptrr p);   // Mar 2018

extern void poly2_to_array(int32_t rows, int32_t start, int32_t high, int32_t low);  // Mar 2018

extern void total_deg_count(poly n, Longiptr high, Longiptr low);  // Mar 2018, Nov 2021

extern void f_total_deg_count(poly n, Longiptr high, Longiptr low, int16_t depth);  // Nov 2021

extern void error(int32_t x, tokentipe *bad);  /* Mar 2009 moved here Aug 2018  */

extern Boolean doing_polymod(void);   // Nov 2018

extern void check_for_null(poly n, int32_t depth, int32_t *m);   // Nov 2018. debugger. May 2019: added extern

extern int32_t qk_poly_numterms(poly n, int16_t depth);  /* May 2019  quick */

extern int16_t fast_polys_there(poly p, int16_t depth);  // Jul 2019

extern Boolean height_is_not_OK(poly n, polypt pt, Boolean *field);  // May 2020. n is not a number on start.  Nov 2021

extern void base_poly_b(polyptrr p, int32_t depth, int32_t b);  // Dec 2021.  |b| < block.

extern int32_t reel_degree(poly q);  // Dec 2021.  There is a real_degree above.

extern Boolean invertible(poly q, polypt pt);  // Dec 2021

extern int32_t call_poly_level_below(poly n);  // Mar 2022

extern void case_one(polyptrr p, polyptrr pden, int16_t target, poly n2, poly d2, polypt pol);  // Mar 2022

extern void case_two(polyptrr p, polyptrr pden, int32_t target, int32_t source, poly n2, poly d2, polypt pol); // Jan 2023

extern void make_two_vars_above_field(poly q, poly *ans, int16_t *dpth, int16_t *lower_depth, int16_t *code, Boolean *cont,
       Boolean do_cont, int16_t *count, int32_t *degr);         // May 2022  May2 2022 Jan 2023

extern void make_two_vars_irred(poly q, poly *ans, int16_t dpth, int16_t lower_depth, int16_t count, int32_t *degr, Boolean *cont, Boolean extra);
    // Jan 2023 Feb 2023

extern void reverse_poly(poly *q);   //  Mar 2022

extern Boolean is_field_element(poly p, int16_t *depth);  // Mar 2022

extern void B(int32_t m);  // Jan 2021  Mar 2022

extern void general_content(poly p, int16_t depth, polyptrr r, polypt pt, Boolean *wantr, Boolean wantcons); /* May 2022 */

extern void poly_display(textptr outf, Boolean outf_is_tty, Boolean flag, poly p, Longiptr mylength,
    tokentipe *endchar, polypt q, Boolean extra_space, Boolean maybe_just_number, Longiptr lines);
  /* May 2022 */

extern int32_t poly_vars_field(poly n, int32_t level, poly_vars_EnvRec *poly_vars_array);  /* May2 2022 */

extern int32_t poly_vars(poly n, int32_t level, poly_vars_EnvRec *poly_vars_array);  /* Jan 2010  May2 2022 */

extern void poly_add(poly n, poly m, polyptrr p);  // Jan 2023

extern void better_poly_add(poly n, poly m, polyptrr p);  // Feb 2023

extern void free_nodes(polyptrr p, int32_t count);  // Feb 2023

extern int32_t j_poly_numterms(poly n, int32_t j, int32_t depth);   // May 2023

extern int32_t j_numterms(quoly n, int32_t j);   // May 2023

extern int32_t f_j_numterms(quoly n, int32_t j);   // May 2023

#endif
