#ifndef FERM120_H
#define FERM120_H 
 
/*  Fermat 64 bit computer algebra system for Linux.
    Copyright (C) 2020 Robert H. Lewis.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* virtual_cut, diskstore for virtual memory.  Jul 2001  */
/*
#include <Types.h>
#include <QuickDraw.h>
#include <Events.h>
#include <OSUtils.h>
#include <Files.h>
#include <Devices.h>
#include <DeskBus.h>
#include <DiskInit.h>
#include <Disks.h>
#include <Errors.h>
#include <Memory.h>
#include <Retrace.h>
#include <SegLoad.h>
#include <Serial.h>
#include <Shutdown.h>
#include <Slots.h>
#include <Sound.h>
#include <Start.h>
#include <Timer.h>
#include <Events.h>
#include <Controls.h>
#include <Desk.h>
#include <Windows.h>
#include <TextEdit.h>
#include <Dialogs.h>
#include <Fonts.h>
#include <Lists.h>
#include <Menus.h>
#include <Resources.h>
#include <Scrap.h>
#include <ToolUtils.h>
#include <FCntl.h>
#include "sane.h"
*/
#include <time.h>
#include <inttypes.h>   // May 2022
#include "unistd.h"

/* added Jun 2011 */
#include <sys/resource.h>

extern FILE *Output, *Input;
#define Trunc(a) (int32_t)(a)  /*AAR*/
#define Round(a) (int32_t)(floor((a)+0.5))  /*AAR*/
#define sqr(a)   ((a)*(a))  /*AAR*/
#define new(a) (a = malloc(sizeof(*a))) /*AAR*/

// OLD #define TickCount (int32_t) (clock() / (CLOCKS_PER_SEC/1000)) /* Jul 2004 */ 

#define TickCount (int64_t) (clock())  /* Mar 2004 -  CLOCKS_PER_SEC = 100 here!!*/  /* Nov 2010. kill the multiply by 10. it just caused overflow */


/*  #define TickCount (int32_t)time(0)    Jul 2004 */
   /* explanation of TickCount:  this will return elapsed cpu and system time,
      NOT real time!  So just doing &T a few times will show no change.
      It's in milliseconds because  CLOCKS_PER_SEC = 1000000 -- NO! see above
       (int32_t) (clock() / (CLOCKS_PER_SEC/1000)) */
      
#define Num2Longint(a)  (int32_t)(a) /*AAR*/
#define RandomX(a)   random()  /*AAR -- note that a doesn't matter*/

/* #define Odd(n)  ((n) % 2 != 0)  Jun 2004 */

#define MAX(a,b) ( (a) > (b)? (a):(b) )    /* Jul 2003 */
#define ustrcpy(a,b) strcpy((char *)a,(char *)b)  /*AAR*/
#define ustrcmp(a,b) strcmp((char *)a,(char *)b)  /*AAR*/
#define ustrlen(a) strlen((char *)a) /*AAR*/

#define num_errors  388  /* Oct 2009 Aug 2010 Sep 2010 Sep2 2010 Oct 2010 Feb 2011 Oct 2011 Nov 2012 Sep 2013 Mar2 2016
                            May 2020  Jun 2021 Dec2 2021 Mar 2022 Oct 2022 May 2023 */
#define sort_mem_size 600000  /* Feb 2005 */

#define block 268435456               /* 2 to the 28 (= logblock) */

#define two_to_28 268435456.00        /*  Note!  It's a real/float */
#define two_to_28i 268435456        /*  Nov 2020 */
#define halfblock 16384               /* 2 to the 14; used for "infinity" many places.
                                            So is 31000. So is 32700. Nov 1996 */
#define newblock 46340                            /* 2 to the 15.5 */
#define bblock 32768                              /* 2 to the 15 */
#define bblck1 32769
#define halfmask 65535                            /* 2^16 - 1 June 1998*/
#define bigprime 48871            /* a big prime. just beyond last_prime. June 1998 */
#define lastprime 48869                           /* June 1998. see primesize too */
#define last_num_prod_size 332                    /* June 1998 */
#define lastmedprime 42349
#define lastbigprime 65521                        /* Dec 2001 */
#define lastlrgprime 2147483629   /* Apr 2004   2^31 - 19. used by expon_node_total. Feb 2008 */
#define subblock 134217728                        /* 2 to the 27 */
#define mask 16383                                /* 2 to the 14 minus 1 */
#define bigmask 268435455                         /* 2 to the 28 - 1, used for "impossibly large" value someplaces. */
#define mediummask 16777215       /* 2 to the 24 - 1; used for "infinity" some place */
#define modlimit 2147483645    /* 2^24; Aug 2001  now 2^31-1 Apr 2004, Sep 2004, - 3 */
#define two_to_17 131072        /* Jun 2000 */
#define two_to_18 262144          /* Jul 2003 */
#define quartmask 32767            /* 2^15 - 1 @@@*/
#define logblock 28
#define twotothirty 1073741824   /* Jul 2010 */

#define num_arrptr 5000           /* note last_arr_spot; changed Aug 2001; was 500; was 1000, changed Sep 2010 to 3000. Jun 2011, 5000 */
#define arr_block_size 1024       /* note last_arr_spot */
#define tenmask 1023                 /* linked to arr_block_size */
#define last_arr_spot 5119999   /* June 1998, 1024 * 1000 - 1. number of spots for all arrays. Jun 2007: changed it 1203999,
                                     SHOULD HAVE DONE THAT IN 2001 !!   Sep 2010   5119999, Jun 2011 */


#define statsize 5000  /* May 2011 */
#define size_r_powers 147
#define size_sm_work_array 40                     /*June 1996*/
#define sqr_size_sm_work_array 1600               
#define arr_limit 1500625  /* max size for any one array = 300^2 (700^2) if gets bigger, Jun 2019
                             check loops in matrix_mult for integerflag. Also note
                             full_charpol is tied to this. May 1998, to 90000 from 40000.
                             to 490000, Aug 2001.  Also note workptr and worksize.
                             changed back to 250000 = 500^2, Oct 2001.
                             Dec 2007: now appears in error message 43. 490000 to 1000000. Sep 2010  Jun 2019 Jan 2020 */
#define millsize 65536    /* max size for Mills method.  not really necessary.  Mills
                             could be rewritten with xmills, emills, etc as sparse.
                             changed to 32767, Nov 2000, was 5000.  Apr2 2016: change to 65536  */
#define powermodcut 10
#define psuedo_logblock 8
#define psuedo_block 100000000
#define negblock (-268435456)   /* used for negative infinity someplaces   Oct 2021 */
#define neg_two_to_31 (-2147483647)
#define two_to_31 2147483647      /* actually 2^31 - 1 */
#define two_to_63 9223372036854775807   /* actually 2^63 - 1 Apr 2020 */
#define two_to_32 4294967296  // Nov 2020

#define primesize 604      /* select_prime uses this. also see basic_mod_method.
                              599 are in primeprods. changed June 1998. Note lastprime */
#define maxauxnum 4583    /* should be primesize - 5 + med_prime_size = 3065. changed June 1998. 3065. add 1518, Mar 2009. note use in compute_aux_primes. 
                             Jan 2010: change error 295.  */
#define size_builtin 123    /* Jul 2008. Mar 2009. Oct 2009. Jan 2010. Feb 2010 Aug 2010 Sep 2010 Oct 2010  Feb 2011 Apr2 2011 Mar2 2016 Apr 2016 May 2016 Jan 2017 Sep 2017 Feb 2018 Mar 2018 May2 2019 May 2021 Jan 2022 Mar 2022 Apr 2023 */
#define nilpotcut 60             /* just a guess. May 24, 1996 */
#define factlimit 1754           /* change this at some point. better C(n,r) */
#define full_charpol 1223         /* dimension of highest char poly ever used.  1223 Jan 2020
                                    (full_charpol+2)^2 = arr_limit) 498 to 998, Sep 2010.*/
#define charpol 38             /* dimension of highest char poly stored in disk file. */
#define in_house_charpol 38      /* 18 dimension of highest char poly stored in array. */
#define first_step 11            /*  dimension of highest char poly loaded first. */
#define sparsesize 1048576       /*  was 2^18. Dec 2007.  general rule on sparseptrs: if you create it, you nil it. 2048 Jun2 2019 16777216
                                    Careful changing this.  Too small might mess up zippel and the setting of row_limit.  Keep it
                                    around 20000 anyway.  In the old days, with smaller RAM, 2048 was prudent.  Mar 2020 changed to 2^20 */
#define small_prime_size 1229      /* the 1229th prime is 9973. Nov 2002. used by find_missing_vars */
#define med_prime_size 2466     /* for rat_poly determ, aux 1 gcd list; changed June 1997 */
#define big_prime_size 1516       /* Dec 2001, for basic_mod_method */
#define lrgpme_size 4000        /* Apr 2004. to 4000, Nov 2014 */
#define max_number_polys 150    /* must be less than one fourth small_prime_size, Nov 2001 */
                                  /* it's 121 in other versions (?) */
#define hensel_mod_cut 30
#define worksize 20                /* from 10 to 20, Oct 2001 */
#define gcd_table_prime 367
#define gcd_table_size 366
#define arrstashsize 400000          /* all references too. Oct 2005. Jun 2007, to 20000. to 40000, Sep 2010. Apr 2011, 400000 */
#define suppressorcut 100000          /* Sept 1996; May 2001 Feb 2021 was 1000  */
#define sort_size 1000               /* Jul 2002.  500 -> 1000, May 2011 */
#define fast_gcd_cons 25000   /* Jan 2004, usually fast_gcd_size is the same. size of
                                 array for fast array-based poly mult, gcd, etc.  Jul 2010, to 25000 */
#define gcd2_cons 700       /* May 2005. 400 -> 700, Jul 2010. This affects Karatsuba!  Keep 700. */
#define pivot_cons 50000     /* Feb 2009. Oct 2011.  Was 5000!  much too small. */
#define sp_sort_size 5000     /* Sep2 2010 */

#define monohashsize 4194304  // 1048576    4194304  /* Aug 2013. 2^20. was 262144. Note def of H_BITS in fer220.c.  2^19 = 524288    1048576 */
#define monoheapsize 4194304 // 1048576 4194304     /* Sep 2013. half of monohashsize is not enough for "many" poly vars. 524288   */
#define logmonohash  22      // 20  log of monohashsize.   524288 noticeably slows many problems.
 
#define Array_ 0
#define Bin_ 1                                 /* Nov 1997 */
#define CIrred_ 2   // May2 2022
#define Chpoly_ 3
#define Codeg_ 4
#define Coef_ 5                                   /* don't really need */
#define Colreduce_ 6
#define Cols_ 7
#define Content_ 8
#define Deg_ 9
#define Denom_ 10
#define Deriv_ 11
#define Det_ 12
#define Det__ 13  
#define Diag_ 14                              
#define Divides_ 15
#define EGCD_ 16                             /* Oct 2003 */
#define Equal_ 17                              /* Sep 2000 */
#define Equalneg_ 18
#define FFLU_ 19                               /* Apr 1999 */
#define FFLUC_ 20                              /* Apr 1999 */
#define Factor_ 21
#define False_ 22
#define Flcoef_ 23
#define Flevel_ 24                          /* Jan 2022 */
#define Func_ 25                               /* Nov 1997 */
#define Function_ 26                           /* Nov 1997 */
#define GCD_ 27
#define Hampath_ 28
#define Height_ 29
#define Hermite_ 30                            /* July 1998 */
#define Irred_ 31
#define Isprime_ 32
#define Iszero_ 33
#define Killden_ 34
#define LCM_ 35
#define Lcoef_ 36
#define Level_ 37
#define Lmon_ 38
#define Log2_ 39                                /* Dec 2001 */
#define Lower_ 40
#define Lterm_ 41
#define MPowermod_ 42       /* Mar 1999. was MHermite, July 1998; unused as of 30 July 1998 */
#define MSmith_ 43          /* July 1998 */
#define Mcoef_ 44
#define Mfact_ 45           /* May 1998 */
#define Minors_ 46          /* Nov 2000 */
#define Minpoly_ 47
#define Modmode_ 48
#define Modulus_ 49
#define Mono_ 50            /* Jul 2006 */
#define Mons_ 51
#define Move_ 52            /* Sep 2000 */
#define Nextvar_ 53   // Mar 2022
#define Nlcoef_  54         /* Oct 2005 */
#define Nmcoef_  55         /* Jul 2008 */
#define Normalize_ 56
#define Ntcoef_ 57        /* Jul 2008 */
#define Numb_ 58
#define Numcon_ 59
#define Numer_ 60
#define Numvars_ 61
#define PDivides_ 62
#define PRoot_ 63
#define Phash_ 64    // Dec 2016
#define Poly_ 65               /* Apr2 2011 */
#define Powermod_ 66
#define Prime_ 67
#define Prod_ 68
#define Pseudet_ 69
#define RRand_ 70
#define Raise_ 71
#define Rand_ 72           /* TYPO!  Was 68. May 2010 */
#define Rat_ 73
#define Rcoef_ 74                   /* Nov 1997 */
#define Redrowech_ 75              /* Oct 2000 */
#define Remquot_ 76
#define Return_ 77
#define Revarry_ 78              /* Apr2 2011 */
#define Revpoly_ 79   // Mar 2022
#define Rname_ 80                                /* Nov 1997 */
#define Rowech_ 81        // Feb 2018
#define Rowreduce_ 82                          /* Nov 2000 */
#define Rows_ 83       // Apr 2016
#define SDet_ 84              /* Oct 2009 */
#define SDivide_ 85
#define STrans_ 86                         /* Dec 2007 */
#define Sigma_ 87
#define Smith_ 88                   /* July 1998 */
#define Sort_ 89                   /* Sep 2010 */
#define Sparse_ 90
#define Splice_ 91       /* Aug 2010 */
#define Split_ 92        /* Aug 2010 */
#define Sqfree_ 93
#define Sqrt_ 94
#define Sumup_ 95
#define Swap_ 96                              /* Sep 2000 */
#define Switchcol_ 97
#define Switchrow_ 98
#define Synth_ 99       /* Oct 2010 */
#define Terms_ 100
#define Termsf_ 101      /* Mar 2009 */
#define Time_ 102        /* Feb 2010 */
#define Timecpu_ 103      /* Sep 2017 */
#define Toot_ 104      /* Feb 2010 */
#define Totdeg_ 105
#define Trace_ 106
#define Trans_ 107
#define True_ 108
#define Var_ 109
#define Vars_ 110        /* Jan 2010 */
#define Verbose_ 111        // Apr 2023
#define WDeg_ 112        // Mar 2018
#define What_ 113        /* May 2016 */
#define X_ 114           /* Jan 2011 */
#define Xmono_ 115      /* Jun 2021 */
#define ZD_ 116   // Jan 2017
#define ZDO_ 117   // May 2021
#define ZZ1_ 118
#define ZZ2_ 119
#define ZZ3_ 120
#define Zcol_ 121     /* Mar2 2016 */
#define Zncoef_ 122    /* Jul 2008, Mar2 2016 Apr 2016 */
#define Zx_ 123    // May2 2019. intentional crash.

#define default_gc 30    /* Feb 2006. Sep 2015, was 10. find all occurrences in all files of g_cutoff. 30 is good.  */

#define two_to_30 1073741824  /* Feb 2009 */

#define mono_array_size 500000   /* Aug 2013 150000  Oct2 2013 200000 May 2016 500000.  Mar 2020: tested various possibilities. */

// typedef unsigned __int128   __uint128_t;  // Apr 2022  Jun 2022. Compiler now objects to these defs!  Never used so I deleted them.
// typedef  __int128   __int128_t;  // Apr 2022

typedef unsigned char nametype [11];
   /* if change the 10, see procedure listvars. Jul 2002 */

typedef int16_t test_array[max_number_polys + 1];   /* for polygcd;  */
/*    BUG Aug 2000, was 0..20 */
/* moved here Nov 2001 */

typedef unsigned char shortstring [2];
typedef unsigned char bigstring [256];

typedef int32_t *lintptr;
typedef int16_t *intptr;                            /* May 2000 */

typedef FILEPtr *textptr;

struct tokentipe {
  nametype name;
  int16_t address;
};
typedef struct tokentipe tokentipe;

typedef PSet_BigSet stuff[16];

typedef struct numnode *numptr;
struct numnode {
  numptr next;
  int32_t value;
};
typedef struct numnode numnode;

typedef numptr *numptrptr;

typedef struct number *imptr;

// ALEX_ANNOTATION
struct number {
  numptr head;
  numptr tail;
  imptr imag;
  int32_t lint;        /* Jun 2010, rearrangement! */
  int16_t size;
                      /* Note!  largest is 111 pages long */
};
typedef struct number number;
typedef imptr *imptrptr;

// ALEX_ANNOTATION
typedef struct polynode *poly;
struct polynode {                   /* prod_size depends on the layout of a poly. Jul 2001 */
  int32_t exp;
  Boolean numb;      /* Jun 2010, rearrangement! */
  poly next;
  union {
    imptr ncoef;
    poly pcoef;
  } variant;
};
typedef struct polynode polynode;

// ALEX_ANNOTATION
typedef struct quolynode *quoly;
struct quolynode {
	quoly next;
	Boolean numb;   /* Jun 2010, rearrangement! */
	Boolean arr_arg;
	Boolean rat;
	union {
    struct {
      imptr ncoef;
    } vc_1;     /* arr_arg is set by insert, iinsert, etc. */
    struct {
      poly numer;
      poly denom;
    } vc_2;
  } variant;
};

/* Jul 2013. new monomial structures */
typedef struct mononode *mono;
struct mononode {  /* exponent array stored as 128 bits, next pointer, coef pointer */
	mono next;       /* this must be first in the record */
	int64_t lint;    /* for modular arithmetic. tried uint64, Sep 2013. back to int64_t. careful of this in the addition inside hash_lint_standard. */
	imptr ncoef;		 
	Boolean size_is_1;  /* used in rational mode only */
	__uint128_t expar;
};
typedef struct mononode mononode;

typedef struct smallmononode *smono;    /* Aug 2013 */
struct smallmononode {    
	__uint128_t expar;
	int32_t lint;  /* for modular arithmetic */
	imptr ncoef;
	Boolean size_is_1;    // Sep 2013
};
typedef struct smallmononode smallmononode;   /* Aug 2013 */

typedef smallmononode mono_array[mono_array_size + 1];   /* Aug 2013. mono_array_size = 50000. boost to 150000 to 200000 */
typedef mono_array *mar_ptr; 

typedef mono hashmarr_array[monohashsize + 1];   // Aug 2013
typedef hashmarr_array *hash_ptr;

typedef struct heapnode *hmono;    /* Aug 2013 */
struct heapnode {    
	__uint128_t expar;
	int32_t ind;  	 
};
typedef struct heapnode heapnode;   /* Aug 2013 */

typedef heapnode monoheap[monoheapsize + 1];   /* Aug 2013. mono_array_size = 50000. boost to 150000 to 200000 */
typedef monoheap *heap_ptr;

typedef struct quolynode quolynode;

typedef quoly *quolyptr;
typedef poly *polyptrr;                           /*spar*/
typedef mono *monoptr;    /* July 2013 */

// ALEX_ANNOTATION
// What is this? 
typedef struct varnode *varptr;
struct varnode {
  tokentipe let;
  varptr next;
  quolyptr qp;
  quoly val;
};
typedef struct varnode varnode;

enum classtype {
  zzero,
  one,
  two,
  three
};
typedef enum classtype classtype;      /* used in fixdata and namenode below */

typedef struct fixdata *fixptr;
struct fixdata {
  polyptrr prev;
  poly node;
  classtype special;
  fixptr next;
};
typedef struct fixdata fixdata;

/* sparse matrix types */
typedef struct colnode *colm_ptr;
struct colnode {
  int32_t coord;             /* usually a column */
  quoly val;
  colm_ptr next;
};

typedef colm_ptr *colm_ptrptr;

typedef struct sparse_fixdata *sparse_fixer;      /* Feb 2004 */
struct sparse_fixdata {
  colm_ptrptr prev;
  colm_ptr node;
  sparse_fixer next;
};
typedef struct sparse_fixdata sparse_fixdata;

typedef struct namenode *nameptr;
struct namenode {
  tokentipe let;
  nameptr nother;                                 /* next node with same name */
  quolyptr qp;                                    /* compiled value */
  nameptr next;
  Boolean compiled;                               /* used by compiler */
  Boolean space;
  /* space added Dec 1997; used by funcdef */
  classtype tipe;
};
typedef struct namenode namenode;

typedef struct polydata *polypt;
struct polydata {
  tokentipe let; 
  /*May 1996*/
  int32_t polycut;               /* used along with 'roots' for pth-roots */
  int32_t expon;
  int32_t modls;
  poly p;                    /* the modder, and alternate version if modder is numb */
  poly alt;
  /* when polymodout; used by fast_fold */
  /* used and set only by powermod */
  poly multdata;    /* used for pth roots; set only by a call to pth_root */
  poly pwr;
  poly roots;
  Boolean field;
  int16_t depth;                     /* used by armand_modular */
  int16_t aux_num;
  imptr gcd_data;                  /*  used by armand_modular */
  polypt next;
};
typedef struct polydata polydata;

typedef struct condnode *condexptr;
typedef struct formnode *formptr;
struct condnode {
  nameptr cond;
  Boolean aloop;
  formptr form1;
  formptr form2;
  nameptr expr;
  condexptr next;
};
typedef struct condnode condnode;

typedef struct comnode *comptr;
struct comnode {
  nameptr q;
  comptr next;
};
typedef struct comnode comnode;

struct formnode {
  condexptr cptr;
  comptr comms;
  formptr next;
};
typedef struct formnode formnode;

typedef struct paramnode *paramptr;
struct paramnode {
  tokentipe let;
  nameptr nother;
  quolyptr qp;
  Boolean result;
  Boolean arry;
  Boolean sparse;
  paramptr next;
};
typedef struct paramnode paramnode;

typedef struct funcnode *funcptr;
struct funcnode {
  tokentipe name;
  paramptr pars;
  formptr rht;
  formptr comp;                                   /* compiled part */
  Boolean do_params;
  funcptr next;
};
typedef struct funcnode funcnode;

typedef funcptr func_st_type[71];

typedef char errmess[66];                         /* to 66, Nov 2000 */

typedef struct colnode colnode;  

typedef struct rowarray *sparseptr;
struct rowarray {
  colm_ptr indx[sparsesize];
     /* for modularmode */
     /* for adjoining/canceling poly vars */
  Boolean modmode;
  Boolean notdone;
  sparseptr next;
};
typedef struct rowarray rowarray;

typedef struct arrnode *arrptr;
struct arrnode {
  tokentipe name;
  int32_t start;                       /* for created sparse, = 0 */
  int32_t stop;                        /* for created sparse, = -1 */
  number sizearr;                   /* for normal, = stop-start+1. always in rational mode
                                       format.  Oct 2000 */
  int32_t rows;
  sparseptr spar;
  Boolean linear;                   /* created linear  */
  arrptr next;
  arrptr father;
  int32_t time;                        /* negative for array params, Oct 2001 */
};
typedef struct arrnode arrnode;

typedef arrptr arr_st_type[151];    /* Jul 2002 */

typedef struct statnode *statptr;
struct statnode {
  statptr prev;
  funcptr f;
  statptr next;
};

typedef struct statnode statnode;

typedef struct messarray *messptr;
struct messarray {
  errmess mess[num_errors];
};

typedef struct messarray messarray;

struct sortrec {	/* Jul 2002 */
  nametype name;
  int32_t count;    /* Jul 2007, used only by do_sorted_var_list in array listings. */
  varptr pt;
};
typedef struct sortrec sortrec;
typedef sortrec sort_array[sort_size];            /* Jul 2002 */
typedef sort_array *sort_ptr;                     /* Jul 2002 */

typedef struct col_pair *colptr;
struct col_pair {
  int32_t i;
  int32_t j;
  quoly f;
  colptr next;
};
typedef struct col_pair col_pair;
typedef quoly storerec[arr_block_size];
typedef storerec *storeptr;

typedef storeptr one_array[num_arrptr];
typedef quoly workarray[arr_limit];
typedef workarray *workptr;
typedef quoly small_wkarray[millsize];
typedef small_wkarray *small_wkptr;

typedef int64_t ptr_array[sort_mem_size];  /* Jul 2004, Feb 2005. Jun 2010: NOTE: Yes, int64 */

typedef quoly small_workarray[sqr_size_sm_work_array];

struct arr_descr {
  number arrsize;
  int32_t rows;                                      /* size and rows; changed Oct 2000 */
};
typedef struct arr_descr arr_descr;

typedef Boolean boolarray[6];                     /* Mar 1999; was 4 */

typedef imptr binomarray[1900];
typedef binomarray *binomptr;

typedef quoly polarray[in_house_charpol][in_house_charpol];
typedef polarray *charpolptr;
typedef int32_t indexarray[charpol - 1][charpol];
typedef indexarray *indexptr;
typedef number primeprodarray[primesize - 5];   // primesize = 604   Feb 2020  + 1 - 7 + 1
typedef primeprodarray *primeprodptr;

typedef imptr auxprimes[maxauxnum];   /* maxauxnum was increased in Mar 2009 */
typedef auxprimes *primeptr;
typedef int16_t small_prime_list[small_prime_size];
typedef small_prime_list *small_prime_ptr;
typedef int32_t med_prime_list[med_prime_size];
typedef med_prime_list *med_prime_ptr;

typedef int32_t big_prime_list[big_prime_size];
typedef big_prime_list *big_prime_ptr;            /* Dec 2001 */

typedef int32_t lrgpme_list[lrgpme_size];   // lrgpme_size = 4000   Feb 2020
typedef lrgpme_list *lrgpme_ptr;            /* Apr 2004 */

typedef int16_t hampathdata[10001];                 /* Nov 1996 */
typedef hampathdata *hampath;

typedef int32_t sparsedetarr[quartmask];    /* Nov 1996, Nov 2000. Oct 2013  quartmask = 32767 */
typedef sparsedetarr *sparsedet;

typedef int64_t sparsedetarr64[quartmask];    /* Oct2 2013  quartmask = 32767 */
typedef sparsedetarr64 *sparsedet64;

typedef int32_t sparsecoldeg[halfmask];              /* Mar 2004 */
typedef sparsecoldeg *sparsecdeg;

typedef int32_t sparsered[mono_array_size];      /* Mar2 2016.  for sparse redrowech, 200000 May 2016 500000 */
typedef sparsered *sparser;

typedef sparseptr spar_arr[4];                    /* June 1998 */

typedef arrptr arrstasharray[arrstashsize];  /* added here July 1998*/
typedef arrstasharray *arrstashptr;

typedef int32_t gcd_array[fast_gcd_cons + 1];   /* Jan 2004.  fast_gcd_cons = 25000. Jul 2010 */
typedef gcd_array *gcd_ptr;      /* Oct 2003, Jan 2004 */

typedef int32_t gcd1_array[gcd2_cons + 1];   /* May 2005   gcd2_cons: 400 -> 700. Jul 2010  */
typedef gcd1_array *gcd1_ptr;      /* May 2005 */

typedef int64_t pivot_array64[pivot_cons + 1];   /* Oct 2013, to 64 bit */
typedef pivot_array64 *pivot_ptr64;               

typedef gcd1_array gcd2_array[gcd2_cons + 1];   /* May 2005 */
typedef gcd2_array *gcd2_ptr;      /* May 2005 */

typedef int32_t pivot_array[pivot_cons + 1];   /* Feb 2009 */
typedef pivot_array *pivot_ptr;                  /* Feb 2009 */

typedef quoly pivotq_array[pivot_cons + 1];   /* Feb 2009 */
typedef pivotq_array *pivotq_ptr;                  /* Feb 2009 */

typedef uint32_t *unsignptr;

typedef Boolean explist[max_number_polys + 1];  /* Apr 2011. see polys_there in fer320.c  */

struct save_EnvRec {  /* moved Jul 2007 */
  /* newname is already given if called from set_switch. S means close old saved file
     and open new one, but write nothing.  s means if necessary, get name of new 
     file, then write functions, vars, etc. */
  
  arrptr p;
  int32_t i;                                         /* Jul 2002 */
};

typedef struct save_EnvRec save_EnvRec;

struct listvars_EnvRec {  /* moved Jul 2007 */
  /* Big changes Jul 2002, sorting. */
  
  arrptr q;
};
typedef struct listvars_EnvRec listvars_EnvRec;

extern sparse_fixer sparse_fix;                   /* Feb 2004 */
extern sparsecdeg cdeg;                           /* Mar 2004 */
extern int32_t colalloc;  /* Apr 2004 now unused */

extern sparser rowred;     // Mar2 2016
extern Boolean rowred_inuse;   // Mar3 2016

/*AAR -- MACRO  Jun 2003 */
#define newnum(q)  {\
  if(numhead == NULL){ \
     q = (numptr)get_slug(numstash); \
  } else { \
     q = numhead; \
     numhead = numhead->next; \
  } \
}

/* Apr 2004 */
#define newcolmm(q)  {\
  if(colm_garb == NULL){ \
    (q) = (colm_ptr)get_slug(colmstash); \
    /* colalloc ++; */  \
  } else { \
     (q) = colm_garb; \
     colm_garb = colm_garb->next; \
  } \
}

#define freenum(h,t) { \
  (t)->next = numhead; \
  numhead = h; \
}

struct poly_vars_EnvRec {  /* Jan 2010  moved here May2 2022*/
  test_array list;
};

typedef struct  poly_vars_EnvRec poly_vars_EnvRec;

extern poly polygarb;

extern mono monogarb;  /* Jul 2013 */

extern int32_t watch_numptr;  /*AAR -- temporary*/

#define freepoly(h,t) {\
  (t)->next = polygarb; \
  polygarb = h; \
}

/* Jul 2013 */
#define freemono(h,t) {\
(t)->next = monogarb; \
monogarb = h; \
}

extern int64_t bigmask64;     // Sep 2013
extern int64_t big64;         // Sep 2013

extern int64_t sparse_cutoff;  // Sep2 2016
extern int64_t big_sparse_cut;  // Sep2 2016
extern int64_t biggest_cut;  // Oct 2016
extern int64_t bigger_sparse_cut;  // Jan 2017
extern int64_t big_size;   // May 2019

extern sort_ptr sortp;             /* Jul 2002 */

extern Boolean changed_in_modmode; /* Feb 2005 */
extern Boolean char2_degs1;  /* Mar 2005 */

extern int32_t size_data_strucs;      /* Jul 2003 */
extern int32_t simplest_poly_cutoff;  /* Oct 2003, cutoff for modularmode one variable */
extern int32_t gcd_stash_cutoff;      /* Dec 2003 */
extern int32_t small_gcd_stash_cut;   /* Dec 2003 */
extern int32_t fast_mult_cut;         /* Oct 2003, cutoff for using the fastest method convert 
                                      to simple array, for one var modmode multiply. */
extern quoly sysnum;
extern quoly prevnum;
extern quoly quolygarb;
extern number number_0;
extern number number_1;
extern number number_2;
extern number number_m1;
extern number number_10;
extern number disp_cons;
extern number num_log_2;
extern number num_log_r;
extern number num_log_10;
extern number rand_denom_n;
extern number num_2_14;
extern int32_t disp_size;                            /* Jul 2001 , Aug 2002 */
extern int32_t statcount;
extern int32_t m_interrupt;
extern int32_t modulus;
extern int32_t half_modulus;
extern int32_t addresser;
extern int32_t multcut;
extern int32_t sqcut;
extern int32_t func_def_count;
extern int32_t namelength;
extern int32_t array_time;
extern int32_t massnum;
extern int32_t depthnum;
extern int32_t quolysize;
extern int32_t trial_cutoff;
extern uint64_t initial_memory;   /* Oct2 2010 */
extern int32_t polygcd_stack_depth;
extern int32_t dummy;
extern int32_t negzero;
extern int32_t numnodesize;
extern int32_t mod_matrix_size;
extern int32_t neg_exponent_warning;
extern int32_t globalpoly;
extern int64_t virtual_cut;  /* Oct2 2010 apparently unused */
extern int32_t uninit;
extern int32_t was_modulus;
extern int32_t prev_modulus;                 /* Dec 2003 */
extern int32_t numbersize;
extern int32_t polynodesize;
extern int32_t cmd_modder;

extern int32_t ddummy;  /* May 2005 */
extern int32_t bozo;

extern double rmodulus;                  /*AAR*/ /* Aug 2001 */
extern tokentipe token;
extern numptr numhead;
extern nameptr name_garb;
extern sparseptr spargarb;
extern imptr imhead;
extern varptr var_garb;
extern colm_ptr colm_garb;
extern varptr sca_store[151];
extern arr_st_type arr_store;                     /* Jul 2002 */
extern func_st_type func_store;
extern arrptr arr_garb;
extern arrptr syst;
extern arrptr duparr;
extern FILEPtr inpuf;
extern FILEPtr outpuf;
extern FILEPtr ferstartup;
extern messptr erp;
extern polypt pt_garb;
extern one_array arp;                             /* main data structure for arrays*/
extern statptr first;
extern statptr lastf;
extern statptr u;
extern /*extended*/ double log_of_2;  /*AAR*/
extern /*extended*/ double log_of_10;
extern /*extended*/ double random_ext;
extern /*extended*/ double random_ext2;
extern /*extended*/ double two_thirty1;
extern Boolean leave_flag;                        /* Jul 1999; Mar 2001; Jul 2001, Aug 2001 */
extern Boolean exit_flag;
extern Boolean cycle_flag;
extern Boolean modularmode;
extern Boolean lintmode;
extern Boolean using_new_polynames;
extern Boolean command_int;
extern Boolean syst_dump;
extern Boolean need_to_set_char_poly;
extern Boolean alt_form_display;
extern Boolean done_load;
extern Boolean tt_flag;
extern Boolean extra_line;
extern Boolean mod_is_prime;
extern Boolean no_aux_primes2;
extern Boolean pos_mod;
extern Boolean minus_warning;
extern Boolean mod_mode_matrix_in_use;
extern Boolean verbose;
extern Boolean danger_ok;
extern Boolean was_in_rat;
extern Boolean monomial_list;
extern Boolean hen_check;
extern Boolean windy;
extern Boolean mod_matrix_ok;
extern Boolean chinhensel;
extern Boolean nomodpolyreadin;
extern Boolean close_inpuf;
extern Boolean smallmodulus;
extern Boolean diskstore;

extern Boolean f256;  /* Jun 2004 */
extern Boolean f2t16;  /* Jul 2004 */
extern Boolean finf;  /* Jul 2004 */
typedef int16_t f256_array[256][256];
typedef f256_array *f256prod_ptr;	/* Jun 2004 Jun 2006 */
extern f256prod_ptr f256prod;		/* Apr 2004 Jun 2006 */
extern int16_t f256inv[256];  /* Jun 2004 */
extern int16_t f256sqr[256];  /* Jun 2004 */
/* extern f256_array f256prod; MAC version. Jun 2006 */ 

extern uint16_t f2t16inv[65536]; /* Jul 2004 */
extern uint16_t f2t16exp[65536]; /* Jul 2004 */
extern uint16_t f2t16log[65536]; /* Jul 2004 */
extern uint16_t f2t16sqr[65536]; /* Jul 2004 */

extern int32_t deglist[max_number_polys + 1];   /* Dec 2005 */

extern sparseptr spsort[sp_sort_size];  /* Sep2 2010. spsort is auxiliary index array for sorting a sparse array. */
extern Boolean using_spsort;            /* Sep2 2010 */

extern int32_t pow_10[9];
extern int32_t ones[32];             /* Nov 2000 */
extern int32_t numblocks;            /* number of array blocks currently activated */
extern FILEPtr errs20;            /* smallest prime in primelist is used in mod_poly_determ */
extern FILEPtr primelist;
extern FILEPtr bprimes;            /* Dec 2001 */
extern FILEPtr lrgpmes;            /* Apr 2004 */
extern FILE *ferstore;                            /* Jul 2001 */
/* obsolete Sep 2003 extern FILE *char_poly_data; */
extern FILE *chdat;  /* Sep 2003 */
/* extern FILE *char_poly_index; obsolete  Sep 2003 */
/* extern FILE *primeprods;  obsolete Sep 2003 */
extern FILE *pprods;   /* Sep 2003 */
extern FILE *pow2028;
extern FILE *pow228;   /* Sep 2003 */
extern stuff throwaways;
extern stuff cond_set;
extern stuff poly_cond_set;
extern stuff term_set;
extern stuff iterm_set;
extern stuff arr_term_ops;
extern stuff continset;
extern stuff short_set;
extern number tens_base;
extern number two_tensbase;
extern Boolean cancelflag;
extern number two_28[130];
extern int32_t factnum[22];
extern number facts[22];
extern nametype builtin[size_builtin+1][2];
extern int32_t numbuiltins;
extern int16_t mod_is_changed;
extern int16_t field_depth;
extern int16_t aux_num_1factor;
extern int16_t aux_num_2factor;
extern int16_t lookupgcd;
extern int16_t dumpitt_level;
extern int16_t dumpitt_length;

extern quoly denom[full_charpol];                 /* sample points for characteristic poly */
extern charpolptr pol;                            /* used for characteristic poly */
extern indexptr pol_index;
/* prods: array[1..full_charpol] of quoly;   prods of sample points for characteristic poly */
extern nameptr start;
extern nameptr finish;
extern nameptr s2;

extern primeprodptr num_prod;
extern primeprodptr lrgnum_prod;   // Feb 2020
extern imptr prime[primesize];                    /* the big ones, from primeprods*/
extern int32_t invs_prod[primesize - 6];   // Feb 2020  - 7 + 1
extern int32_t lrginvs_prod[primesize - 6];   // Feb 2020

extern int32_t small_arr[13];                        /* used by find_pseudo for smith normal form */

extern arrstashptr arrstash;                      /* July 1998 */

extern fixptr masterfix;            /* masterfix is a stack of changes made to polys
                                       going into modularmode the fast way. The changes
                                       come about because of nodes becoming 0. It's
                                       important that it is a stack.*/
extern fixptr fixgarb;
extern colptr colgarb;
extern binomptr binom;

extern workptr workhead[worksize];          // worksize = 20    Mar2 2016
extern workptr stash;                             /* system's space for its array syst */

extern small_wkptr xmills;                        /* spar; used by Mills */
extern small_wkptr emills;
extern small_wkptr fmills;

extern primeptr auxptr;                           /* doesn't need to be initialized */
extern int16_t aux_prime1_number;                   /* type 1 auxiliary primes */
extern Boolean aux1_hit_0;                        /* May 1998, report if aux_prime1_number BECAME 0 */
extern small_prime_ptr small_prime;
extern med_prime_ptr med_prime;
extern big_prime_ptr big_prime;    /* Dec 2001 */
extern lrgpme_ptr lrgpme;         /* Apr 2004 */

extern formptr formhead;
extern condexptr condhead;

extern quoly gcd_stash[gcd_table_size + 1];

extern workptr mod_mode_matrix;
extern workptr dupptr;

extern uint32_t mytime[9][2];     /* These vars to keep track of elapsed time. note unsigned. also in fer222.c. Feb 2010 */
extern uint32_t breaktime[9][2];  /* at each command level. */
extern uint32_t time_off[9][2];
extern int16_t time_level;
extern int32_t fast_gcd_size;

extern Boolean try_rat; /* Jul 2005 */
extern Boolean rat_yes; /* Jul 2005 */
extern Boolean do_line_sup; /* Oct 2005 */
extern polypt dodo;  /* Nov 2005   alternate list of names*/

extern Boolean in_sys_func;  /* Apr 2007 */

extern int32_t alg_c_count; /* Mar 2008 */ 
extern int32_t original_depth;   /* Feb 2011 */

extern int32_t pseudet_heur;   /* Jun 2008 */

extern int32_t warn_cnt;   /* Oct 2011 */
extern int32_t factorflip;  // Oct 2016
extern int32_t row_limit;  // Oct 2016

extern poly deb1;   // Jan 2017   debuggers
extern poly deb2;
extern poly deb3;

extern Boolean dozippel;  // Feb3 2017

extern int32_t line_number;   // Dec2 2017. line number in file being loaded.
extern int32_t file_pos;      // Dec2 2017. position in file being loaded.
extern Boolean in_funcdef;    // Dec2 2017. All three of these are to display the line number if an error occurs loading a file.

extern Boolean consume_n; // Mar 2022. to facilitate reusage of storage in poly_div_no_q, for one poly mod another.
                          //  Only quoly_mod_or_div can turn it on.  poly_mod_or_div might turn it off.

/* Feb 2010: note: CLOCKS_PER_SEC is 1000000 */
/* Feb 2010: note: clock() counts millionths of seconds from program start. eg:  401665505 means 401.665505 seconds
                      CPU time from starting this invocation of fermat.
                   time(0) counts seconds REALTIME, apparently from about 1969! */
				   
/* Feb 2010: big revision below. Occasionally, elapsed time would display a negative value in the seconds field, becuase clock()
   was overflowing!  As noted above, clock() returns millionths of a second. So a command like
   mytime[0][1] = timetemps[0][1] - mytime[0][1] - time_off[0][1] can overflow after 35 minutes! Fix is below.
   Just be honest with the user. CAREFUL: check that this is what happens in Linux! */

#define RecordTime(a,lev) { \
  /*printf("Time was %d and %d\n",a[lev][0], a[lev][1]); */\
  a[lev][1] = clock(); \
  a[lev][0] = time(0); \
 /* printf("line %d: Recorded time got %d and %d\n",__LINE__,a[lev][0], a[lev][1]); */\
}

/* Feb 2010: huge changes below.  Now display both real and CPU. */
#define ReportTime(a,lev) { \
  float secpart = ((float)(a[lev][1]%CLOCKS_PER_SEC))/CLOCKS_PER_SEC; \
  int32_t hours = a[lev][0]/(60*60); \
  int32_t mins = (a[lev][0]%(60*60))/60; \
  int32_t secs2 = a[lev][0]%60; \
  int32_t secs = (a[lev][1]/CLOCKS_PER_SEC)%60;     /* was (a[lev][0]%60), Feb 2004 */ \
  int32_t mins2 = (a[lev][1]/CLOCKS_PER_SEC)/60; \
  char strtemp[10]; \
  if (secpart < 0) \
    secpart = -secpart; \
  sprintf(strtemp,"%0.3f", secpart); \
/*  fprintf(stdout," Elapsed time(%d): %d:%2ld:%2ld.%s\n",a[lev][0],hours,mins,secs,&strtemp[2]); */ \
  if (hours > 0)   \
     fprintf(stdout," Elapsed real time: %u:%u:%u.  CPU time: %u:%u.%s\n", hours, mins, secs2, mins2, secs, &strtemp[2]); \
  else if (mins > 0)  \
     fprintf(stdout," Elapsed real time: %u:%u.  CPU time: %u:%u.%s\n", mins, secs2, mins2, secs, &strtemp[2]); \
  else if (secs2 > 4)  \
     fprintf(stdout," Elapsed real time: %u.  CPU time: %u.%s\n", secs2, secs, &strtemp[2]); \
  else \
     fprintf(stdout," Elapsed CPU time: %u.%s\n", secs, &strtemp[2]); \
}

extern arr_descr sys_arr_facts;       /* moved Oct 2000 */

extern void newnode(numptrptr p);

extern void newimag(imptrptr p);

extern void newfix(fixptr *p);

extern void newform(formptr *p);

extern void newcond(condexptr *p);

extern void newsparse(sparseptr *p);

extern void newcol(colptr *q);

extern void newarray(arrptr *q);                    /* Oct 2000 */

extern void free_num(imptr x);                      /* Oct 2000 changed name */

extern void special_free(imptr x);                  /* Oct 2000 */

extern int32_t quotient_of(imptr n, int32_t m);         /* Oct 2000 */

extern Boolean is_product_of(imptr num, int32_t n, int32_t m);  /* Oct 2000 */

extern Boolean is_longint(imptr num, int32_t n);     /* Oct 2000 */

extern void free_imag(imptrptr p);

extern void freename(nameptr p);

extern void free_form(formptr *p);

extern void free_cond(condexptr *p);

extern void makeneg(imptr num, imptr x);

extern void in_place_neg(imptr num);

extern void num_assign(imptr n, imptr x);

extern void spec_num_assign(imptr n, imptr x);       /* Oct 2000 */                        

extern void fast_num_assign(numptr p, int16_t size, imptr x);

extern void faster_num_assign(numptr p, int16_t size, imptrptr x);  /* May 2005 */

extern void fast_assign(numptr p, int16_t size, imptr x);

extern Boolean bigger(imptr n, imptr m);

extern Boolean pos_bigger(imptr n, imptr m);      /* Jul 2002 */

extern Boolean equal(imptr n, imptr m);

extern Boolean negtive(imptr n, imptr m);         /* Sep 2000 */

extern Boolean spec_equal(imptr n, imptr m);      /* Oct 2000 */

extern Boolean equal_which(imptr n, imptr m, Boolean *firstone);  /* Jun 2000 */

extern void setvalue(int32_t n, imptr x);

extern void special_set(int32_t n, imptr x);           /* Oct 2000 */

extern void special_set_2(int32_t n, int32_t m, imptr x);  /* Oct 2000 */

extern void medsum(int16_t nsize, int16_t msize, numptr p, numptr q, imptr ans);

extern void meddiff(int16_t nsize, int16_t msize, numptr p, numptr q, imptr ans);

extern void summ(imptr n, imptr m, imptr ans, int32_t vblock); /*was block*/

extern void fastsum(imptr n, imptr m);

extern void fastdiff(imptr n, imptr m);

extern void fast_modout(imptr n, imptr pseudodet);

extern void simp_mult(imptr n, imptr ans, int32_t m, numptrptr penult);

extern void multiply(imptr n, imptr m, imptr ans);

extern void fast_mult(imptr n, imptr m, imptr ans);

extern Boolean int_abs_bigger(imptr firstn, imptr secondn, Boolean equalok);  /* July 1998 */

extern Boolean abs_larger(imptr firstn, imptr secondn);

extern void abs_val_num(imptr n, imptr m);

extern void subinitialize(char *);

extern int32_t minn(int32_t a, int32_t b);                 /* Jul 2002 moved here  */

extern int32_t maxx(int32_t a, int32_t b);                 /* Jul 2002 moved here  */

extern int64_t maxx64(int64_t a, int64_t b);            /* May 2012 */

extern int16_t Iminn(int16_t a, int16_t b);             /* Jul 2002 moved here  */

extern int32_t logg2(imptr q);                       /* Jul 2002 moved here  */

extern int32_t logg2_neg(imptr q);                   /* Jul 2002 moved here  */

extern int32_t logg2lint(int32_t q);                    /* Dec 2001; Jul 2002 moved here  */

extern int32_t max_digits(poly q);                   /* Dec 2001; Jul 2002 moved here  */

extern int32_t quoly_max_digits(quoly q);            /* Dec 2001; Jul 2002 moved here */

extern int32_t number_mass(quoly p);    /* Jun 2008 */

extern int32_t smallgcd(int32_t u, int32_t v);

extern void binary_gcd(imptr n, imptr m, imptr ans);  /* Jul 2002 */

extern void gcd(imptr n, imptr m, imptr ans);

extern void extgcd(imptr n, imptr m, imptr gcd, imptr qn, imptr qm, Boolean *gcd1);  /* Jun 1999 */

extern void gcdnum(quolyptr n, quolyptr m);

extern void pos_divide(imptr n, imptr d, imptr quot, imptr rem);

extern void pos_divide_noq(numptr nhead, numptr dhead, numptr dtail, int16_t nsize, int16_t dsize, imptr rem);

extern void divide(imptr n, imptr d, imptr quot, imptr rem);

extern void make_base_10(imptr n, imptr n2);

extern void verybig_base_10(numptr p, numptr t, int16_t size, imptr n2);

extern void int_sqrt(imptr n, imptr n2, Boolean flag);

extern Boolean equal_to_pm1(imptr n, Boolean *its_minus1);

extern void simp_base_10_mult(imptr n, imptr ans, int32_t m, numptrptr penult);

extern void base_10_multiply(imptr n, imptr m, imptr ans);

extern void base_10_fast_mult(imptr n, imptr m, imptr ans);

extern int32_t modout(imptr n);

extern Boolean oversize(int32_t n, int32_t m);          /* June 1998 */

extern Boolean sparse_oversize(int32_t n, int32_t m);   /* June 1998 */

extern void Deci(intptr x);                        /* Sep 2002 */

extern void fermat_error(/*bigstring*/char * mess, Boolean push); /* AAR */

extern Boolean power_of_two(int32_t n);   /* Nov 2004 */

extern Boolean its_a_square(int32_t n);  /* Dec 2004 */

extern int32_t second_aux_num;   /* Mar 2009 */

extern int32_t modular_sqrt(int32_t n);   /* Aug 2011 */

extern int32_t modmult(uint32_t x, uint32_t y);     /* Apr 2004   moved here Sep2 2016 */

extern void newpt(polypt *p);     /* moved here Sep2 2016 */

extern void mod_number_power(int32_t n, int32_t e, Longiptr ans);  /* Aug 2011   moved here Sep2 2016  */



#endif
