#ifndef BUILTINS_H
#define BUILTINS_H

#include "types.h"
#include <stdio.h>
#include <string.h>  /* for memcpy, memset */

typedef void *Pointer;
typedef FILE *FILEPtr;


#ifdef __cplusplus
extern "C" {
#endif


extern int32_t ArgC;
extern char **ArgV;
extern char **Env;
extern void InitArgCArgV(int32_t theArgC, char **theArgV, char **theEnv, Boolean cvtToPString);
extern int32_t PB_Power(int32_t base, int32_t n);


#define MoveLeft(s, d, l)  memcpy(d, s, l)
#define MoveRight(s, d, l) memmove(d, s, l)
#define FillChar(s, n, c)  memset(s, c, n)
#define Odd(n)  ((n) % 2 != 0)

#define BAnd(a, b) 	((uint32_t)(a) & (uint32_t)(b))
#define BOr(a, b) 	((uint32_t)(a) | (uint32_t)(b))
#define BXOr(a, b) 	((uint32_t)(a) ^ (uint32_t)(b))
#define BNot(a) 		(~(uint32_t)(a))
#define BSL(a, b) 	((uint32_t)(a) << ((b) & 0x3FUL))
#define BSR(a, b) 	((uint32_t)(a) >> ((b) & 0x3FUL))
#define BRotL(a, b) ((uint32_t)(a) << ((b) & 0x3FUL)) | ((uint32_t)(a) >> (32UL - ((b) & 0x3FUL)))
#define BRotR(a, b) ((uint32_t)(a) >> ((b) & 0x3FUL)) | ((uint32_t)(a) << (32UL - ((b) & 0x3FUL)))
#define BTst(a, b)	(((uint32_t)(a) & (1UL << (b))) != 0)
#define HiWrd(a) 		((uint16_t)((uint32_t)(a) >> 16UL))
#define LoWrd(a) 		((uint16_t)((uint32_t)(a) & 0xFFFFUL))
#define BClr(a, b) 	(a = ((uint32_t)(a) & (~(1UL << (b)))))
#define BSet(a, b)	(a = ((uint32_t)(a) | (1UL << (b))))

#ifdef __cplusplus
}
#endif


#endif
