/*---------------------------------------------------------------------------*
 |                                                                           |
 |                    <<< PSets.h - Pascal set routines >>>                  |
 |                                                                           |
 *---------------------------------------------------------------------------*/

/* This file contains:

	
*/

#ifndef __PSETS__
#define __PSETS__

#ifndef __TYPES__
#include "types.h"
#endif


#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned char PSet_Set8;
typedef uint16_t PSet_Set16;
typedef uint32_t PSet_Set32;
typedef uint16_t PSet_BigSet;

extern void PSet_Init(uint16_t *theSet, short nbrWords);
extern void PSet_Set(uint16_t *theSet, short nbrWords, uint32_t theElem);
extern void PSet_SetRange(uint16_t *theSet, short nbrWords, uint32_t elem1, uint32_t elem2);
extern Boolean PSet_Test(uint16_t *theSet, short nbrWords, uint32_t theElem);
extern Boolean PSet_Eq(uint16_t *set1, uint16_t *set2, short nbrWords);
extern Boolean PSet_Subset(uint16_t *set1, uint16_t *set2, short nbrWords);
extern Boolean PSet_Subset2(uint32_t set1, uint32_t set2);
extern uint16_t *PSet_Difference(uint16_t *dest, uint16_t *set1, uint16_t *set2, short nbrWords);
extern uint16_t *PSet_Intersection(uint16_t *dest, uint16_t *set1, uint16_t *set2, short nbrWords);
extern uint16_t *PSet_Union(uint16_t *dest, uint16_t *set1, uint16_t *set2, short nbrWords);


#ifdef __cplusplus
}
#endif

#endif
