/* storage allocation scheme-- taken from Macaulay*/
#ifndef _STASH_
#define _STASH_
#include <stdlib.h>


typedef void *POINTER;

#define BLOCKSIZE 262144  /*   1048576  524288 pick any good size 8816 */

#define WORD sizeof(int32_t *)
#define numtext  BLOCKSIZE/sizeof(int32_t)
typedef struct text_struct *ptext;
struct text_struct{
        ptext next;
        int32_t textmem[numtext];
};


typedef struct slug *ptslug;
struct  slug {
        struct slug *pslug;
};

struct stashblock {
        struct stashblock *pblock;
        int32_t pad;  /*put things on a boundary of 8*/
        char space[BLOCKSIZE];
};
 
struct stash {
        struct slug *slugs;
        struct stashblock *blocks;
        struct stash *prev, *next;
        char *name;
        int32_t slug_size;
        int32_t n_blocks, n_slugs, slugs_used;
};
 
extern void get_block(struct stash *pstash);
extern POINTER get_slug(struct stash *pstash);
extern struct stash *open_stash(int32_t size, char *name);
extern void free_slug(struct stash *pstash, struct slug *ptr);
extern int32_t *get_small(int32_t number);  /*get space for 'number'  integers*/
extern void endof_stash(struct stash *pstash);

extern struct stash *polystash;
extern struct stash *quolystash;
extern struct stash *numstash;
extern struct stash *colmstash; /* Apr 2004 */
extern struct stash *imagstash;
extern struct stash *monostash;  /* Jul 2013 */

#endif
